/*
 * realchebyshev.c
 *  pop a vector of chebyshev coeficient, pushes its roots
 *  uses eigenvalues from companion (implicit) matrix
 *  port from fortran90 by Jared Aurentz
 *  www.math.wsu.edu/students/jaurentz/
 *  Created on: Sep 7, 2014
 *      Author: skai
 */

#include <hpgcc3.h>
// #include <hpgraphics.h>

// ARMCODE_CONFIG_STACK_STANDARD
// TO KEEP THE KEYBOARD AND TIMERS ENABLED, USE INSTEAD:
// ARMCODE_CONFIG(_STACK_SPEED_120MHZ);
//ARMCODE_CONFIG(startup)= /*_NO_SCREEN  |  _NO_WAITKEY |_NO_KEYBOARD| */ _SPEED_120MHZ;
ARMCODE_CONFIG(startup)= _NO_SCREEN  |  _NO_WAITKEY |_NO_KEYBOARD|  _SPEED_120MHZ;
ARMCODE_CONFIG(memory_req)=USE_MAINRAM|USE_ERAM|USE_KOSRAM|RESERVE_TEMPOB(16)|RESERVE_USEROB(16);

// int forced_to_matrix=0;
//int push_as_vector=0;
//int debug=1;
//int  mode;
//int hpdigits;

#include "hadamard.h"




int main(){
    int ma,na,mb,nb,m=0, n=0, k,l;
    SAT_OBJECT sat_a, sat_b, sat_c;
//    int file_index;
//    char  file[2][16] ={{"chebvec0.dat"},{"chebvec1.dat"}};
 //   double re,im, **mata, **matb;
    XREAL ra,rb,r;
    /* get data from calculator stack */
    sat3_cknerror(2);								// require two inputs on stack
    if(sat3_checkargs(2,SAT_DOARRY, SAT_DOARRY))	// 2: vector 1:realflag
    {

//    	matb=sat_create_pop_double_matrix(&mb,&nb);
//    	mata=sat_create_pop_double_matrix(&ma,&na);
//    	if (!((ma==mb)&&(na==nb))) sat3_exiterror(SATERR_INVALIDDIMENSION);
//    	m=ma;n=na;
//    	for (k=0;k<m;k++){for(l=0;l<n;l++){mata[k][l]*=matb[k][l];}}
//        free_matrix2(m,n,matb);
//        sat_push_double_matrix(m,n,mata);
//        free_matrix2(m,n,mata);
//
    	sat_b=sat3_pop(); sat3_rarraysize(sat_b,&mb,&nb);
    	sat_a=sat3_pop(); sat3_rarraysize(sat_a,&ma,&na);
    	m=ma;n=na;
    	if ((ma!=mb)||(na!=nb)) sat3_exiterror(SATERR_INVALIDDIMENSION);
    	sat_c=sat3_createrarray(ALLOC_HEAP,m,n);
    	if(!m) m++; if(!n) n++;
    	for (k=0;k<m;k++){for(l=0;l<n;l++){
    		sat3_rarrayget_xreal(sat_a,k,l,&ra);
    		sat3_rarrayget_xreal(sat_b,k,l,&rb);
    		xr_mul(&ra,&rb,&r);
    		sat3_rarrayput_xreal(sat_c, k,l,&r);
    	}}
    	sat3_push(sat_c);
    }


    else  sat3_exiterror(SATERR_BADARGTYPE);
    return 0;
}


