/*
 * chebroots.h
 *
 *  Created on: Sep 7, 2014
 *      Author: skai
 */
#include <hpgcc3.h>
#ifndef CHEBROOTS_H_
#define CHEBROOTS_H_
extern int forced_to_matrix;
extern int push_as_vector;
extern int debug;

#define NULL 						0
#define PI  (3.14159265358979)
#define SYSFLAG                      0x80F02
#define USERFLAG                     0x80F22
#define RAD_FLAG					17
#define FIX_ENG_FLAG				49
#define SCI_ENG_FLAG				50
// hpdigits are   flag 45-6-7-8
#define HPDIGITS_FLAG				45
#define HPSYSFLAG_COMMA_MODE		51
#define HPSYSFLAG_TINY_ELEMENT		54




#define WINDOW_WIDTH  				131
#define WINDOW_HEIGHT  				80

#define Too_Few_Arguments 513	/* #201 err number in HP */
#define Bad_Argument_Type 514	/* #202 err number in HP */
#define Invalid_Syntax 262	    /* #106 err number in HP */
#define Positive_Underflow 769 	/* #301 err number in HP */
#define Negative_Underflow 770	/* #302 err number in HP */
#define Overflow 771			/* #303 err number in HP */
#define Undefined_Result 772  	/* #304 err number in HP */
#define Infinite_Result 773  	/* #305 err number in HP */
#define Invalid_Dimensions 1281	/* #501 err number in HP */
#define INVALID_SYNTAX     		262
#define	INVALID_USERFUNCTION   	259		// undefined function , or name not A,B,C,D
#define NOT_ENOUGH_ARM_MEMORY	 43    // buffer overflow, increase MAX_TOKEN and recompile


#define fsqrt sqrt
typedef struct {
	union {
		double r[5];
		struct {double xmin, xmax,dx, ymin,ymax;};
	};
} PLOTDATA, *PLOTDATA_PTR;

typedef struct {
	union {
		double r[2];
		struct {double x, y;};
	};
} CMP, *CMP_PTR;

int *  create_ivector(int n);
double *  create_vector(int n);
CMP * create_cvector(int m);
double * sat_create_pop_double_vector(int *elements);
void	const_ivector(int n, int r, int *v);
void	const_vector(int n, double r, double v[]);
void	const_matrix(int m, int n, double r, double **mat);
BOOL sat_push_double_vector(int elements,double *vector);
BOOL sat_push_double_matrix(int rows,int columns,double **array);
// BOOL sat_push_double_cmatrix(int rows,int columns,double **rarray, double **iarray);

// BOOL sat_push_double_zvector(int n,CMP *cvector);
BOOL sat_push_double_cvector(int n,double *rvector, double *ivector);

double * copy_vector(double *cpy, double *orig,int n);

double ** create_matrix2(int m, int n);
double ** sat_create_pop_double_matrix(int *m,int *n);
void free_matrix2(int m,int n,double **a);

CMP ** create_cmatrix2(int m, int n);
void free_cmatrix2(int m,int n,CMP **a);
void sort_vector(int n, double *b, double *a, double *t);

double * der1(int nm1, double * a, int bigrange, double aa,double bb);

double fx(double x, double **data, double *t, int m );
int do_plot(double **data,double *t, int m, int nn, PLOTDATA plot);
double chebx(double x,double *data,int m );
// double chebx1(double x,double **data,int m );
double *chebcoef ( double *c, int m);
double fbarydx(double x, double f, double **data, double *t, int m );
int rescheck_skai( double *wr, double *wi, double *pol, double *tmp, int n, double ab_rms[2], int complexresult, int Allroots);


void swap(double *x, double *y);

CMP cmp_complex(double a, double b);
CMP cmp_add(CMP a, CMP b);
CMP cmp_sub(CMP a, CMP b);
CMP cmp_mul(CMP a, CMP b);
CMP cmp_div(CMP a, CMP b);
CMP fcmp_mul(double a, CMP b);
CMP fcmp_XX_mul(double a, CMP b);
CMP fcmp_div(double a, CMP b);
CMP fcmp_add(double a, CMP b);
int DAVW2(int BANDSWITCH,int N,int K,double *POLY,double **COEFFS,double *RROOTS,double *IROOTS,int *ITERATIONS);
int DBLR(                int N,int K,double *POLY,double **COEFFS,double *RROOTS,double *IROOTS,int *ITERATIONS, int INIT,int CHASE);
int DGATO(double *r11,double *r12, double *r21, double *r22, int A, int B, double L[4],int LL);
int DBB(double L[4], int start, int N,double *blocks_11,  double *blocks_12,  double *blocks_21,  double *blocks_22, int switch_flag);
int DGLTO(double L[4]);
void DBP(double L[4], int LL,int start, int top, int bottom, int N, int K, double **Bands);
void dnormalpoly(double *poly, int start, int stop);
double *vecscale(double *wr, double r1, int n);
double *vecaddscalar(double *wr, double r0, int n);
// int fftini(  double *a, int n, int task );
int write_vector_to_SD(double *a, int n, char* name  );
int read_vector_from_SD(double *a, int *n, char* name  );
int read_vector_dims_from_SD(int *n, char* name  );
int get_vector_from_SD(double *vector, int *n, char* name  );
int cheb_balance(double balanse_factor, double *T, int N, double *r);
double * chebsamplemain( double *rx, double a, double b, int nder, int n);
double ** create_matrix2_f(int m, int n); // option base 1, but still row based c-style
void free_matrix2_f(int m,int n,double **a);    //
double get_pole(double a,double b, double *T,int n);
BOOL get_sysflag( int sysflag);
BOOL get_userflag( int userflag);
void sat_get_hpdigits();
void sat_get_mode();
#endif /* CHEBROOTS_H_ */
