/*
 * barycheb.c
 *
 *  Created on: May 16, 2014
 *      Author: skai
 */



#include <hpgcc3.h>
#include <hpgraphics.h>

// ARMCODE_CONFIG_STACK_STANDARD
// TO KEEP THE KEYBOARD AND TIMERS ENABLED, USE INSTEAD:
// ARMCODE_CONFIG(_STACK_SPEED_120MHZ);
ARMCODE_CONFIG(startup)= /*_NO_SCREEN  |  _NO_WAITKEY |_NO_KEYBOARD| */ _SPEED_120MHZ;
ARMCODE_CONFIG(memory_req)=USE_MAINRAM|USE_ERAM|USE_KOSRAM|RESERVE_TEMPOB(16)|RESERVE_USEROB(16);


#include "barycheb.h"
double fx(double x, double **data, double *t, int m ){
// double fx(x,  **data, *t, m );

	int found=FALSE, indeks=0, i;
	double y;
	register double dx;
	register double rx=0.0;
	register double ry=0.0;
	for ( i=0;i<m;i++)if (data[i][0]==x) { indeks=i;found=TRUE; break;}
	if (!(found)){
		for ( i=0;i<m;i++){
			dx=x-data[i][0];
			dx= t[i]/ dx;
			ry+=data[i][1]*dx;
			rx+=dx;
		}
		y=ry/rx;
	}
	else y=data[indeks][1];
return y;
}
double fbarydx(double x, double f, double **data, double *t, int m ){
// double fbarydx( x, f, **data, *t, m );

	int found=FALSE, indeks=0, i;
	double  y, idx, dy, dt, fi,ti;
	register double rx=0.0;
	register double ry=0.0;
	for ( i=0;i<m;i++)if (data[i][0]==x) { indeks=i;found=TRUE; break;}
	if (!(found)){  // x is not a node
		for ( i=0;i<m;i++){
			idx=1.0/(x-data[i][0]);
			dt= t[i]*idx;
			dy= dt*(f-data[i][1])*idx;
			rx+=dt; ry+=dy;
		}
		y= ry/rx;
	}
	else {

		fi=data[indeks][1];
		ti=t[indeks];
		for ( i=0;i<m;i++){
			if (!(i==indeks))ry+=-t[i]*(data[i][1]-fi);
		}
		y=ry/ti;

	}

return y;
}


double *chebcoef ( double *c, int m){
	int i;
	const double dx= PI/(m-1);
	for (i=0; i<m;i++)c[i]=cos( i*dx);   //	create [n+1]vector  chebyshev  2 kind
	return c;
}




double *chebweight ( double *t, int m, int use_modified ){
//	double *chebweight ( double *t, int m, int use_modified );
	int isign, i;
	//     Chebyshev type 2 weights
	isign=-1; for ( i=0;i<m;i++){isign=-isign;t[i]=isign;} t[0]*= 0.5;t[m-1]*=0.5;
	if (use_modified) { t[0]*= 0.5;t[1]*= 0.75;t[m-2]*=0.75;t[m-1]*=0.5; } //     if equividistant use modified  type 2 weights
	return t;}

double chebx(double x,double **data,int m ){
	int i;
	double y,y2=0.0,y1=0.0,y0;
	y0=data[m-1][0];
	for ( i=1;i<=m;i++){
		y2=y1;
		y1=y0;
		y0=2*y1*x-y2+data[m-i][0];
	}
	y= (data[0][0]+y0-y2)*.5;
	return y;
}

int do_plot(double **data,double *t, int m, int nn, PLOTDATA plot){
//	do_plot( **data,*t, m, nn, *plot)
	int i,n;
	int px0,px1,py0,py1;
	double x0,y0,x1,y1;
	double xscale,yscale;

	hpg_set_mode_mono(1);hpg_clear(); hpg_flip();hpg_clear();
	if (plot.ymin==plot.ymax){plot.ymin=-1.0;plot.ymax=1.0;}
	xscale= WINDOW_WIDTH/(plot.xmax-plot.xmin);
	yscale= WINDOW_HEIGHT/(plot.ymax-plot.ymin);
	/*  draw simple axis */
	py0= (plot.ymax-0.0)*yscale;
	if((py0>=0)&&(py0<=WINDOW_HEIGHT))hpg_draw_line(0,py0,WINDOW_WIDTH,py0); // x
	px0= (0.0-plot.xmin)* xscale;
	if((px0>=0)&&(px0<=WINDOW_WIDTH))hpg_draw_line(px0,WINDOW_HEIGHT,px0,0); // y axis



	n= (plot.xmax-plot.xmin)/plot.dx+1;
	x0=plot.xmin;
	if (nn>1) y0 =fx(x0, data, t, m );else y0=chebx(x0,data,m );
	px0= (x0-plot.xmin)* xscale;
	py0= (plot.ymax-y0)*yscale;

	for (i=0;i<n;i++){
		x1=plot.xmin+plot.dx*i;
		if (nn>1) y1 =fx(x1, data, t, m );else y1=chebx(x1,data,m );

		px1= (x1-plot.xmin)* xscale;
		py1= (plot.ymax-y1)*yscale;

		hpg_draw_line(px0,py0,px1,py1);
//		if (((y0<=0.0)&&(y1>=0.0))||((y0>=0.0)&&(y1<=0.0))) {
//  		y0=chebroot(data,m, x0,y0, x1,y1,nn, t);
//			sat3_push_dbl_real(y0);sat3_push_dbl_real(y1);
//			}
		px0=px1;py0=py1;
		y0=y1;

	}
    hpg_flip();

	return 0;
}
int main (){
	int  k,i,m,n, nx=1, indeks=0;
	int vectormode=FALSE, use_modified=FALSE;
	double x,dx, *t=NULL,**data=NULL, *X=NULL;
//	CMP z;
	SAT_OBJECT listobj;
	PLOTDATA  plot;
	sat3_ckn(2);  // sat3_exiterror();
	if(sat3_checkargs(2, SAT_DOREAL, SAT_DOREAL)){ // note reverse stack, ie: :2:real, :1:real
		vectormode= TRUE;
		indeks=sat3_pop_int(0);
		m=sat3_pop_int(0);
		nx=m+1;
		if(m) X=create_vector(nx);
		switch (indeks){
		case  0: for (i=0; i<nx;i++)X[i]=i+1; break;                                 //	create [n+1]vector   1.. n+1
		case  1: dx=2.0/m;for (i=0; i<nx;i++)X[i]=i*dx-1.0; break;                   //	create [n+1]vector  -1..1
		case  2: dx= PI/m;for (i=0; i<nx;i++)X[i]=cos( i*dx); break;                 //	create [n+1]vector  chebyshev  2 kind
		case  3: X=chebweight ( X,nx, FALSE );  break;                               //	create [n+1]vector  chebyshev  2 kind weights [.5 -1 ..1. -1. .5]
		case  4: dx= PI/(2*nx);for (i=1; i<=nx;i++)X[i-1]=cos( (2*i-1)*dx); break;   //	create [n+1]vector  gauss chebyshev
		default: sat3_push_string("n 1: uniform -1..1\nn 2: chebyshev 2\nn 3: [ .5 -1 ..1 -1 -.5] \nn 4: gauss-chebyshev"); goto finish; break;
		}
		goto ferdig;

	}
	else if(sat3_checkargs(2, SAT_DOARRY, SAT_DOARRY)){ // note reverse stack, ie: :2:Arry, :1:Arry
	// [X,Y], X -> Y'
		vectormode=TRUE;
		X=sat_create_pop_double_vector(&nx);
		data=sat_create_pop_double_matrix(&m,&n);
	}
	else if(sat3_checkargs(2, SAT_DOREAL, SAT_DOARRY)){ // note reverse stack, ie: :2:Arry, :1:REAL
	// [X,Y], X -> Y'
		vectormode=FALSE;
		x=sat3_pop_dbl(0.0);
		X=create_vector(nx); X[0]=x;
		data=sat_create_pop_double_matrix(&m,&n);
	}
	else if(sat3_checkargs(2, SAT_DOLIST, SAT_DOARRY)){ // note reverse stack, ie: :2:Arry, :1:list
	// [X,Y], {x0,x1,dx, auto} -> plot
		vectormode=TRUE;
		listobj=sat3_pop();
		for (i=0;i<5;i++) plot.r[i]=sat3_convertreal_dbl(sat3_listget(listobj,i)); // xmin,xmax,dx,ymin,ymax
		data=sat_create_pop_double_matrix(&m,&n);
		t=create_vector(m);
		t=chebweight ( t,m, FALSE );
		do_plot( data,t, m,n, plot);

		WAIT_CANCEL;
		free_matrix2(m,n,data);
		free(t);
		goto finish;
	}
	else sat3_exiterror(SATERR_BADARGTYPE);
	if  ( m<2 || n<1 || n>3 ) sat3_exiterror(SATERR_INVALIDDIMENSION );
	else if (n==1) {t=create_vector(1);	for(k=0;k<nx;k++) X[k]=chebx(X[k],data,m );}
	else {
		//     Chebyshev type 2 weights
		t=create_vector(m);
		use_modified= ((m>3 )&&(fabs((data[1][0]-data[0][0])/(data[2][0]-data[1][0])-1.0) <1E-10));
		t=chebweight ( t,m, use_modified );   // if equividistant use modified  type 2 weights
		for(k=0;k<nx;k++) X[k]=fx(X[k],data,t, m ); // for all xi
		if (n==3){
			for(k=0;k<nx;k++) X[k]=fbarydx(data[k][0], X[k], data, t, m );
                			// double fbarydx(     x,   f,  **data, *t, m );

		}
	 }
	free_matrix2(m,n,data);
	free(t);
	ferdig:
	if(vectormode)sat_push_double_vector(nx,X);
	else sat3_push_dbl_real(X[0]);
	free(X);
	finish:
	return (0);
};
