/*
 * misc.c
 *
 *  Created on: Sep 7, 2014
 *      Author: skai
 */



#include <hpgcc3.h>
//#include <hpgraphics.h>


#include "chebroots.h"
//double fx(double x, double **data, double *t, int m ){
//// double fx(x,  **data, *t, m );
//// barycentric interpolation
//	int indeks=FALSE, i;
//	double rx=0.0,ry=0.0, y,dx;
//	rx=0.0;
//	ry=0.0;
//	indeks=FALSE;
//	for ( i=0;i<m;i++){if ( data[i][0]==x) indeks=i;}
//	if (!(indeks)){
//		for ( i=0;i<m;i++){
//			dx=x-data[i][0];
//			dx= t[i]/ dx;
//			ry+=data[i][1]*dx; rx+=dx;
//		}
//		y=ry/rx;
//	}
//	else y=data[indeks][1];
//return y;
//}


double *chebcoef ( double *c, int m){
	int i;
	const double dx= PI/(m-1);
	for (i=0; i<m;i++)c[i]=cos( i*dx);   //	create [n+1]vector  chebyshev  2 kind
	return c;
}




double *chebweight ( double *t, int m, int use_modified ){
//	double *chebweight ( double *t, int m, int use_modified );
	int isign, i;
	//     Chebyshev type 2 weights
	isign=-1; for ( i=0;i<m;i++){isign=-isign;t[i]=isign;} t[0]*= 0.5;t[m-1]*=0.5;
	if (use_modified) { t[0]*= 0.5;t[1]*= 0.75;t[m-2]*=0.75;t[m-1]*=0.5; } //     if equividistant use modified  type 2 weights
	return t;}

double chebx(double x,double *data,int m ){
	// Chebyshev interpolation
	int i;
	double y,y2=0.0,y1=0.0,y0;
	y0=data[m-1];
	for ( i=1;i<=m;i++){
		y2=y1;
		y1=y0;
		y0=2*y1*x-y2+data[m-i];
	}
	y= (data[0]+y0-y2)*.5;
	return y;
}
/*
 *
*/

//int do_plot(double **data,double *t, int m, int nn, PLOTDATA plot){
////	do_plot( **data,*t, m, nn, *plot)
//	int i,n;
//	int px0,px1,py0,py1;
//	double x0,y0,x1,y1;
//	double xscale,yscale;
////	hpg_t *HPG_STDSCREEN;
// //   hpg_t  *g;
// //   g=hpg_alloc_mono_image(WINDOW_WIDTH,WINDOW_HEIGHT);
//
//	hpg_set_mode_mono(1);hpg_clear(); hpg_flip();hpg_clear();
//	if (plot.ymin==plot.ymax){plot.ymin=-1.0;plot.ymax=1.0;}
//	xscale= WINDOW_WIDTH/(plot.xmax-plot.xmin);
//	yscale= WINDOW_HEIGHT/(plot.ymax-plot.ymin);
//	/*  draw simple axis */
//	py0= (plot.ymax-0.0)*yscale;
//	if((py0>=0)&&(py0<=WINDOW_HEIGHT))hpg_draw_line(0,py0,WINDOW_WIDTH,py0); // x
//	px0= (0.0-plot.xmin)* xscale;
//	if((px0>=0)&&(px0<=WINDOW_WIDTH))hpg_draw_line(px0,WINDOW_HEIGHT,px0,0); // y axis
//
//
//
//	n= (plot.xmax-plot.xmin)/plot.dx+1;
//	x0=plot.xmin;
//	if (nn>1) y0 =fx(x0, data, t, m );
//	else y0=chebx(x0,data,m );
//	px0= (x0-plot.xmin)* xscale;
//	py0= (plot.ymax-y0)*yscale;
//
//	for (i=0;i<n;i++){
//		x1=plot.xmin+plot.dx*i;
//		if (nn>1) y1 =fx(x1, data, t, m );else y1=chebx(x1,data,m );
//
//		px1= (x1-plot.xmin)* xscale;
//		py1= (plot.ymax-y1)*yscale;
//
//		hpg_draw_line(px0,py0,px1,py1);
//		if (((y0<=0.0)&&(y1>=0.0))||((y0>=0.0)&&(y1<=0.0))) {
//	//		y0=chebroot(data,m, x0,y0, x1,y1,nn, t);
//			sat3_push_dbl_real(y0);sat3_push_dbl_real(y1);}
//		px0=px1;py0=py1;
//		y0=y1;
//
//	}
//    hpg_flip();
//	return 0;
//}


BOOL sat_push_double_vector(int n,double *vector){
	int j;
	SAT_OBJECT sat_array;
    sat_array=sat3_createrarray(ALLOC_TEMPOB,n,0);
    if(sat_array==0){ sat3_exiterror( SATERR_INSUFFMEMORY ); return FALSE;}
    for (j=0;j<n;j++) sat3_rarrayput_dbl( sat_array,j,0,vector[j]);
    sat3_push(sat_array);
    return TRUE;
}
BOOL sat_push_double_cvector(int n,double *rvector, double *ivector){
	int j;
	SAT_OBJECT sat_array;
    sat_array=sat3_createcarray(ALLOC_TEMPOB,n,0);
    if(sat_array==0){ sat3_exiterror( SATERR_INSUFFMEMORY ); return FALSE;}
    for (j=0;j<n;j++) sat3_carrayput_dbl( sat_array,j,0,rvector[j] ,ivector[j]);
    sat3_push(sat_array);
    return TRUE;
}
BOOL sat_push_double_zvector(int n,CMP *cvector){
	int j;
	SAT_OBJECT sat_array;
    sat_array=sat3_createcarray(ALLOC_TEMPOB,n,0);
    if(sat_array==0){ sat3_exiterror( SATERR_INSUFFMEMORY ); return FALSE;}
    for (j=0;j<n;j++) sat3_carrayput_dbl( sat_array,j,0,cvector[j].x ,cvector[j].y);
    sat3_push(sat_array);
    return TRUE;
}

void							/* create constant matrix of double */
const_matrix(int m, int n, double r, double **mat)
{
	int i,j;
	for (i = 0; i < m; i++){for (j=0;j<n;j++){ mat[i][j]=r;}}
}


void							/* create constant vector of double */
const_ivector(int n, int r, int *v)
{
	int i;
	for (i = 0; i < n; i++)
		v[i] = r;
}

void							/* create constant vector of double */
const_vector(int n, double r, double *v)
{
	int i;
	for (i = 0; i < n; i++)
		v[i] = r;
}


int *
create_ivector(int m)
{
     // Dynamically allocate an n vector
	int r=0;
	int *vec;
	if(!(vec = (int *) calloc(m,sizeof(int)))){sat3_exiterror(SATERR_INSUFFMEMORY); return (0);}
	const_ivector(m,r,vec); //	for (i=0;i<m;i++) {vec[i]=r;}
	return (vec);
}

double *
create_vector(int m)
{
     // Dynamically allocate an n vector
	double r=0.0;
	double *vec;
	if(!(vec = (double *) calloc(m,sizeof(double)))){sat3_exiterror(SATERR_INSUFFMEMORY); return (0);}
	const_vector(m,r,vec); //	for (i=0;i<m;i++) {vec[i]=r;}
	return (vec);
}

double *
sat_create_pop_double_vector(int *n)
{
// double sat3_pop_dbl(0.0)
	SAT_OBJECT	eaddr;
int flag=0, rows=0,cols=0,j;
double *vector=0;

	if(sat3_depth()==0) sat3_exiterror(Too_Few_Arguments); //error: too few arguments
    eaddr= sat3_pick(1) ;
	if (!(flag=sat3_rarraysize(eaddr,&rows, &cols)))sat3_exiterror( Bad_Argument_Type );   //error: not an arry
	if ((cols))  sat3_exiterror( SATERR_INVALIDDIMENSION);
	if (!( vector=create_vector(rows))) sat3_exiterror(SATERR_INSUFFMEMORY);
	for (j=0;j<rows;j++) vector[j]=sat3_rarrayget_dbl( eaddr,j,0);
    sat3_drop(); //pop the vector from the stack
    *n=rows;
	return (vector);
}

//
//double **
//sat_create_pop_double_matrix(int *m,int *n)
//{
//	// double sat3_pop_dbl(0.0)
//	SAT_OBJECT	eaddr;
//	int cols=0, rows=0,j;
//	int flag,i;
//	double **arry;
//    forced_to_matrix=0;
//	if(sat3_depth()==0) sat3_exiterror(Too_Few_Arguments); //error: too few arguments
//	eaddr= sat3_pick(1) ;
//	if (!(flag=sat3_rarraysize(eaddr,&rows, &cols)))sat3_exiterror( Bad_Argument_Type );   //error: not an arry
//	if(!(cols)) {cols=1;forced_to_matrix=1;}
//	if (!( arry=create_matrix2(rows,cols))) sat3_exiterror(SATERR_INSUFFMEMORY );
//
//	for (i=0;i<rows;i++){
//			for (j=0;j<cols;j++){
//				arry[i][j]=sat3_rarrayget_dbl( eaddr,i,j);
//			}
//		}
//
//    sat3_drop(); //pop the arry from the stack
//    *m=rows;
//	*n=cols;
//	return arry;
//
//}
//


double **
create_matrix2(int m, int n)
{
     // Dynamically allocate an mxn
     //

	int i;
	const double r=0.0;
	double  **a;
    if(!(a = (double **)calloc(m,sizeof(double *)))) { sat3_exiterror(SATERR_INSUFFMEMORY);  return (0);}
    for (i=0;i<m;i++) {
		if (!(a[i] = (double *)calloc(n,sizeof(double)))){a[0]=0;sat3_exiterror(SATERR_INSUFFMEMORY); return (0);}
	}
	const_matrix(m,n,r,a); //	for (i=0;i<m;i++){for(j=0;j<n;j++){a[i][j]=r;}}
	return a;
}

void
free_matrix2(int m,int n,double **a)    // actually only a list of separate vectors ***
{	// free matrix generated by create_matrix2
	int i;
	n=0;   // avoid warning
	for (i=0;i<m;i++){free(a[i]);}
	free(a);
}
 void							/* create constant matrix of double */
 const_cmatrix(int m, int n, CMP r, CMP **mat)
 {
 	int i,j;
 	for (i = 0; i < m; i++){for (j=0;j<n;j++){ mat[i][j]=r;}}
 }

// BOOL
// sat_push_double_matrix(int rows,int columns,double **array)
// {
// // NOTE: if push_as_vector=TRUE , it is assumed columns=0
// 	int i,j, retval;
//     SAT_OBJECT sat_array;
//     if (push_as_vector) sat_array=sat3_createrarray(ALLOC_TEMPOB,rows,0);
//     else 		   		sat_array=sat3_createrarray(ALLOC_TEMPOB,rows,columns);
//     if(sat_array==0) { sat3_exiterror(SATERR_INSUFFMEMORY); return FALSE;}
//     for (i=0;i<rows;i++){
//        for (j=0;j<columns;j++) {
//     	   sat3_rarrayput_dbl( sat_array,i,j,array[i][j]);
//         }
//     }
// 	retval=sat3_push(sat_array);
// 	push_as_vector=0;
//     return retval;
// }

//
// void							/* create constant vector of double */
// const_cvector(int n, CMP r, CMP *v)
// {
// 	int i;
// 	for (i = 0; i < n; i++)
// 		v[i] = r;
// }
// CMP cmp_complex(double a, double b){
//	 CMP z;
//	 z.x=a;
//	 z.y=b;
//	 return (z);
// }
//
//
// CMP *
// create_cvector(int m)
// {
//      // Dynamically allocate an n vector
// 	CMP r;
// 	r.x=0.0;
// 	r.y=0.0;
// 	CMP *vec;
// 	if(!(vec = (CMP *) calloc(m,sizeof(CMP)))){sat3_exiterror(SATERR_INSUFFMEMORY); return (0);}
// 	const_cvector(m,r,vec); //	for (i=0;i<m;i++) {vec[i]=r;}
// 	return (vec);
// }
//
// CMP **create_cmatrix2(int m, int n)
// {
//      // Dynamically allocate an mxn
//      //
//
// 	int i;
// 	CMP r;
// 	r.x=0.0;r.y=0.0;
// 	CMP  **a;
//     if(!(a = (CMP **)calloc(m,sizeof(CMP *)))) { sat3_exiterror(SATERR_INSUFFMEMORY);  return (0);}
//     for (i=0;i<m;i++) {
// 		if (!(a[i] = (CMP *)calloc(n,sizeof(CMP)))){a[0]=0;sat3_exiterror(SATERR_INSUFFMEMORY); return (0);}
// 	}
// 	const_cmatrix(m,n,r,a); //	for (i=0;i<m;i++){for(j=0;j<n;j++){a[i][j]=r;}}
// 	return a;
// }
//  void
// free_cmatrix2(int m,int n,CMP **a)    // actually only a list of separate vectors ***
// {	// free matrix generated by create_matrix2
// 	int i;
// 	n=0;   // avoid warning
// 	for (i=0;i<m;i++){free(a[i]);}
// 	free(a);
// }
//
//
// CMP cmp_add(CMP a, CMP b){
//	 CMP z;
//	 z.x=a.x+b.x;
//	 z.y=a.y+b.y;
////	 sat3_push(sat3_createcplx_dbl(ALLOC_HEAP, a.x,a.y));
////	 sat3_push(sat3_createcplx_dbl(ALLOC_HEAP, b.x,b.y));
////	 sat3_push(sat3_createcplx_dbl(ALLOC_HEAP, z.x,z.y));
//	 return z;
// }
// CMP fcmp_add(double a, CMP b){
//	 CMP z;
//	 z.x=a+b.x;
//	 z.y=b.y;
//	 return z;
// }
// CMP cmp_sub(CMP a, CMP b){
//	 CMP z;
//	 z.x=a.x-b.x;
//	 z.y=a.y-b.y;
//	 return z;
// }
// CMP cmp_mul(CMP a, CMP b){
//	 CMP z;
//	 z.x=a.x*b.x-a.y*b.y;
//	 z.y=a.x*b.y+a.y*b.x;
////	 sat3_push(sat3_createcplx_dbl(ALLOC_HEAP, a.x,a.y));
////	 sat3_push(sat3_createcplx_dbl(ALLOC_HEAP, b.x,b.y));
////	 sat3_push(sat3_createcplx_dbl(ALLOC_HEAP, z.x,z.y));
//	 return z;
// }
// CMP cmp_XX_mul(CMP a, CMP b){
//	 CMP z;
//	 z.x=a.x*b.x;
//	 z.y=a.x*b.y+a.y*b.x;
//	 return z;
// }
// CMP fcmp_mul(double a, CMP b){
//	 CMP z;
//	 z.x=a*b.x;
//	 z.y=a*b.y;
//	 return z;
// }
// CMP cmp_div(CMP a, CMP b){
//	 double m;
//	 CMP z;
//	 m=1.0/(b.x*b.x+b.y*b.y);
//	 z.x=(a.x*b.x+a.y*b.y)*m;
//	 z.y=(a.y*b.x-a.x*b.y)*m;
////	 sat3_push(sat3_createcplx_dbl(ALLOC_HEAP, a.x,a.y));
////	 sat3_push(sat3_createcplx_dbl(ALLOC_HEAP, b.x,b.y));
////	 sat3_push(sat3_createcplx_dbl(ALLOC_HEAP, z.x,z.y));
//	 return z;
// }
// CMP fcmp_div(double a, CMP b){
//	 double m;
//	 CMP z;
//	 m=1.0/(b.x*b.x+b.y*b.y);
//	 z.x=a*b.x*m;
//	 z.y=(-a*b.y)*m;
////	 sat3_push_dbl_real(a);
////	 sat3_push(sat3_createcplx_dbl(ALLOC_HEAP, b.x,b.y));
////	 sat3_push(sat3_createcplx_dbl(ALLOC_HEAP, z.x,z.y));
//	 return z;
// }
double * copy_vector(double *cpy, double *orig,int n){
	int k;
	for(k=0;k<n;k++) cpy[k]=orig[k];
	return cpy;
}
double *vecscale(double *wr, double r1, int n){
	int i;
	for (i=0;i<n;i++)wr[i]*=r1;
	return wr;
}
double *vecaddscalar(double *wr, double r0, int n){
	int i;
	for (i=0;i<n;i++)wr[i]+=r0;
	return wr;
}



void							/* sort a based on b , vector of double */
sort_vector(int n, double *b, double *a, double *t)
{
	int i, j, p;
	double r0, r1;
	copy_vector(b, t, n);		//copy b to t, if t=b , b will be sorted too

	for (i = 0; i < n - 1; i++)
	{							//loop over vector
		p = i;
		r0 = 1e100;
		for (j = i; j < n; j++)
		{
			if (r0 > t[j])
			{
				p = j;
				r0 = t[j];
			}
		}						// find smallest
		r1 = t[i];
		t[i] = r0;
		t[p] = r1;
		r1 = a[i];
		a[i] = a[p];
		a[p] = r1;				// swap
	}
}


int
write_vector_to_SD(double *a, int n, char* name  ){
	int flag;
//	void *pv;
	FS_FILE *fileptr;
	flag= FSOpen(name, FSMODE_WRITE, &fileptr);
	if (!(flag==FS_OK)){printf("\n OPEN Error \n write mat from SD"); WAIT_CANCEL }
	flag=FSWrite((void *)&n,4,fileptr);
	flag=FSWrite( (void *)a,8*n,fileptr);
	flag=FSClose(fileptr);
	if (!(flag==FS_OK)){printf("\n Close Error \n Write mat from SD"); WAIT_CANCEL }
	return (flag);
}
int
read_vector_from_SD(double *a, int *n, char* name  )
{
	int j,flag;
	void *ptr;
	FS_FILE *fileptr;
	flag=FSOpen(name, FSMODE_READ, &fileptr);
	if (!(flag==FS_OK)){printf("\n Error \n read mat from SD"); WAIT_CANCEL }
	flag=FSRead((char *)n,4,fileptr);
	j=*n*8;

		ptr=a;
		flag=FSRead(ptr, j,fileptr);

//		for(j=0;j< *n;j++){
//			flag=FSRead((void *)&a[i][j],8,fileptr);
//		}


	flag=FSClose(fileptr);
	if (!(flag==FS_OK)){printf("\n Closing Error \n read mat from SD"); WAIT_CANCEL }
	return flag;
}
int
read_vector_dims_from_SD(int *n, char* name  )
{
	int flag;
	FS_FILE *fileptr;
	flag=FSOpen(name, FSMODE_READ, &fileptr);
	if (!(flag==FS_OK)){printf("\n Error \n read mat dims"); WAIT_CANCEL }
	flag=FSRead((char *)n,4,fileptr);

	flag=FSClose(fileptr);
	return flag;
}

//int
//get_vector_from_SD(double *vector, int *n, char* name  ){
//	int flag;
//	read_vector_dims_from_SD(n,name);
//	vector=create_vector(*n);
//	flag=read_vector_from_SD(vector,n,name);
//	return (flag);
//}

void
free_matrix2_f(int m,int n,double **a)    // actually only a list of separate vectors ***
{	// free matrix generated by create_matrix2
	int i;
	++a;
	n=0;   // avoid warning
	for (i=0;i<m;i++) free(++a[i]);
	free(a);
}

double **
create_matrix2_f(int m, int n)
{
     // Dynamically allocate an mxn, memory only assigned for index 1 and upwards
     // Note it is still row order not column order
	// columns not changed , you can do than manually **a=**a-1;

	int i;
	const double r=0.0;
	double  **a;
    if(!(a = (double **)calloc(m,sizeof(double *)))) { sat3_exiterror(SATERR_INSUFFMEMORY);  return (0);}
    for (i=0;i<m;i++) {
		if (!(a[i] = (double *)calloc(n,sizeof(double)))){a[0]=0;sat3_exiterror(SATERR_INSUFFMEMORY); return (0);}
	}
	const_matrix(m,n,r,a); //	for (i=0;i<m;i++){for(j=0;j<n;j++){a[i][j]=r;}}
    for (i=0;i<m;i++) a[i]--;  // option base 1
    a--;
	return a;
}
