/*
 * main.c
 *
 *  Created on: Feb 10, 2015
 *      Author: skai
 */


#include <hpgcc3.h>


// SUGGESTION: USE CUSTOM CONFIGURATION
// THIS STATEMENT WILL DISABLE KEYBOARDS AND TIMERS
// SO tmr_xxx FUNCTIONS WON'T WORK
//ARMCODE_CONFIG_STACK_STANDARD

// TO KEEP THE KEYBOARD AND TIMERS ENABLED, USE INSTEAD:
//ARMCODE_CONFIG(startup)=_NO_SCREEN | _NO_STDIO_INIT | _NO_WAITKEY | _NO_SPEEDCHANGE;
//ARMCODE_CONFIG(memory_req)=USE_MAINRAM|USE_ERAM|USE_KOSRAM|RESERVE_TEMPOB(16)|RESERVE_USEROB(16);

// AND SINCE YOUR PROGRAM USES THE SCREEN, THE BEST CHOICE IS:
ARMCODE_CONFIG(startup)= /*_NO_SCREEN | _NO_STDIO_INIT | */ _NO_WAITKEY | /*_NO_SPEEDCHANGE*/ _SPEED_120MHZ;
ARMCODE_CONFIG(memory_req)=USE_MAINRAM|USE_ERAM|USE_KOSRAM|RESERVE_TEMPOB(16)|RESERVE_USEROB(16);
ARMCODE_CONFIG(slack_space)=10;






char buf[80];
int nbuf;

//BOOL sat_push_double_matrix(int rows,int columns,double **array);
BOOL sat_push_double_vector(int elements,double *vector);
//BOOL sat_push_double_cmatrix(int rows,int columns,double **rarray, double **iarray);
BOOL sat_push_double_cvector(int n,double *rvector, double *ivector);
double * sat_create_pop_double_vector(int *elements);
//double ** sat_create_pop_double_matrix(int *m,int *n);
int *  create_int_vector(int n);
void	const_vector(int n, double r, double v[]);
// void	const_matrix(int m, int n, double r, double **mat);
double ** create_matrix2(int m, int n);
double *  create_vector(int n);
void free_matrix2(int m,int n,double **a);
//int do_mult( int flagTransp0);
//int do_det();
//int do_inv();
//int do_solv( int flagTransp);
// int do_add(int sign);
// int do_geneig();
// int do_choltransform();
int do_chebsolve(int Allroots);
//int dgefa(int n, double **a, int *ipvt);
//void dgesl( int m, int n, double **a,int *ipvt,double **b,int job);
//void dgedi(int n, double **a,int *ipvt,double *det,double *work,int job);
// void add_matrix( int m, int n, double **a, double **b, double **c,int sign);
//double pracc(int n, int i, double **a, double *tmp);    // matrow*vector
//int mult_matrix(int m,int n, int mb,int nb, double **a, double **b,double **c, int flagTransp);
// int * pop_list_create_zint(int *elements);
// unsigned long long sat_double2real(double num);
// double sat_real2double (unsigned address);
// int pop_list_zint(int *l);
// void push_list(int, int *);

/*       these functions are called by hp 49g, reads data and allocated arrays   */
//int do_det();
//int do_inv();
//int do_solv( int flagTransp);
//int do_mult( int flagTransp0);
//int do_eig(int evlOnly);
//int do_expm();
//int do_svd(int task_to_do, double eps, double tol);
//int do_gramschmidt();
//int do_minimax();
//int do_choldecomp(); // Choleski decomposition LL<-A
//int choltransform(double **B, double **U, int m);
//int cholbacksolve(int n , double **a, double **b);
//double geneig(double **b, double **c, double *zr,double *zi,double **b_tmp, double **c_tmp, double **z_tmp,int m, int doRms);		// Bz=lamCz, C pos definit
// int minimax(double *pol, double **data, double *c, double e,int m, int n);
// int spolmm(double **data, double *a,int l); skai2013
// double fnf(double *pol, double x, int n); skai2013
// double fns(double *pol, double xi, double yi, int n); skai2013
// int fsign( double x);
// int do_four1();
/* memory utilities */
// double ** create_matrix(int m, int n); skai2013
//void free_matrix(int m,int n,double **a);
//void update_pointer(int m, int n, double **a);

/* row (vector) one dim. functions, do not use on matrix2 */
void copy_vector(int, double *in, double *out);
void const_vector(int, double, double *);
//void scale_vector(int, double, double *);
//void scadd_vector(int, double f, double *t, double *r, double *s);	// f*t+r->s
//double dotvector(double f, double *a, double *b, int m); // f <- dot(a[m], b[m])
double absmax(int, double *);
//double fnorm2(int, double *);
//double rmsdiff(int, int, double *, double *);
// double rmswdiff(int, int, double *, double *, double*); skai2013
void sort_vector(int, double *b, double *a, double *c);	// a(b), c is scratch (if c=b, b sort too)

/* column functions    */
void copy_col(int n, double **matcopy, int jcopy, double **matorig, int jorig);
void scale_col(int n, int j, double scale, double **mat);
//double* getcolvector(double **a, double *b, int k, int m); //b<-a[k]
//double **putcolvector(double **a, double *b, int k, int m); // a[k] <- b

/* matrix functions   */
//void copy_matrix(int m, int n, double **out, double **in);
void const_matrix(int m, int n, double r, double **);
//void scale_matrix(int m, int n, double scale, double **mat);
//void scadd_matrix(int m, int n, double scale, double **a, double **b, double **c);	// scale*a+c->c, scale*a+b->c
//double pracc(int n, int i, double **a, double *tmp);    // matrow*vector
//int mult_matrix(int m,int n, int mb,int nb, double **a, double **b,double **c, int flagTransp);
//double  **transp(int m, double **a);
//double matnorm2(int m, int n, double **);
//double **mult_mat_diag(int m, int n,double **A, double *d, double **B); // Ai*di-> Bi

/*  building blocks eispack, lapack, etc. */
//int dgefa(int n, double **a  /* [][n] */ , int ipvt[]);
//void dgesl( int m, int n, double **a /* [][n] */ ,int ipvt[],double **b /* [][n] */,int job);
//void dgedi(int n, double **a /* [][n] */,int ipvt[],double det[],double *work,int job);
void split_matrix( int m, int n, double *wr, double *wi, double **v, double **a);
void balanc(int n, double **a, int *lo, int *hi, double *scale);
void balbak(int n,int lo, int hi, double *scale,int m,double **z);
//void elmbak(int n, int lo, int hi, double **a,int *intch,int m, double **z);
void elmhes(int n, double **a, int lo, int hi, int *intch);
void eltran(int n, int lo, int hi, double **a,int *intch,double **z);
void hqr(int n,int lo,int hi,double **h,double *wr,double *wi,int *ierr);
void cdiv(double ar,double ai,double br,double bi,double *cr,double *ci);
void hqr2(int n,int lo,int hi,double **h,double *wr,double *wi,double **z,int *ierr);
//void pnormwr(int n,double **z, double *wr, double *wi);
//int choldecomp(int n, double **L, double *w);
int eig(double **a, double **v, double *wr, double *wi ,int m, int n, int evlOnly);
// double calc_geneig_res(double **B, double **C,  double **Z, double *lam, int m); skai2013
//int read_matrix_dims_from_SD(int *m, int *n, char* name  );
//int read_matrix_from_SD(double **a, int *m, int *n, char* name  );
//int write_matrix_to_SD(double **a, int m, int n, char* name  );

/*  top level functions  */

/*   presently not easy to call the complex functions from c programs */
/*   maybe should use programs to set up memory then options: read/print to file or pop/push stack?   */
/*	or flag the few pop, push functions I actually use, making macros?  */

//int svdsolve(int m, int n, double**, double*, double**, double**,
//			 double*, double*, double*, double*, int, int, int, double,
//			 double);

// double calc_res(int, int, int, int, int, double*, double*, double*,	double*, double*, double*, double*); skai2013
//int sum_integer_list(int n, int *l);
// void four1(double data[], unsigned long nn, int isign);
//double gcd(double v, double w);


// scadd
// rsd a<- A-B*C
// rms <-  abs(a[i]-b[i])
// abs  <- sqrt(SUM( a[i]^2))
// RANM2


// CONVERTED ALL GLOBALS TO CONSTANTS FOR SPEED AND SIZE
#define BIG_ARRAY 16   // large ARRAYS is saved on SD-card in GEGV
#define ZERO 0
#define ONE 1
#define TWO 2
#define minusone  1048575   //#FFFFF
#define DO_ERROR_EXIT -3
#define Insufficient_Memory 1 	// #001 err number in HP
#define Interrupted 319			// #13F err number in HP
#define Too_Few_Arguments 513	// #201 err number in HP
#define Bad_Argument_Type 514	// #202 err number in HP
#define Infinite_Result 773  	// #305 err number in HP
#define Invalid_Dimensions 1281	// #501 err number in HP
#define Unable_to_find_root 49153// #C001 err number in HP
#define SATERR_BADARGVALUE 0x203

#define SWAP(a,b) tempr=(a);(a)=(b);(b)=tempr

int forced_to_matrix=0;
int push_as_vector=0;


void							/* create constant vector of double */
const_vector(int n, double r, double *v)
{
	int i;
	for (i = 0; i < n; i++)
		v[i] = r;
}




void							/* create constant matrix of double */

const_matrix(int m, int n, double r, double **mat)
{
	int i,j;
	for (i = 0; i < m; i++){for (j=0;j<n;j++){ mat[i][j]=r;}}
}

//double /* each column of A is scaled with d[i] */
//**mult_mat_diag(int m, int n,double **A, double *d, double **B){
////  A*d -> B, A*d -> A
//	int i,j;
//	for (i=0;i<m;i++){for(j=0;j<n;j++){B[i][j]=A[i][j]*d[j];}}
//return B;
//}

BOOL
sat_push_double_vector(int n,double *vector){
	int j;
	SAT_OBJECT sat_array;
    sat_array=sat3_createrarray(ALLOC_TEMPOB,n,0);
    if(sat_array==0){ sat3_exiterror(Insufficient_Memory); return FALSE;}
    for (j=0;j<n;j++) sat3_rarrayput_dbl( sat_array,j,0,vector[j]);
    sat3_push(sat_array);
    return TRUE;
}

//BOOL
//sat_push_double_matrix(int rows,int columns,double **array)
//{
//// NOTE: if push_as_vector=TRUE , it is assumed columns=0
//	int i,j, retval;
//    SAT_OBJECT sat_array;
//    if (push_as_vector) sat_array=sat3_createrarray(ALLOC_TEMPOB,rows,0);
//    else 		   		sat_array=sat3_createrarray(ALLOC_TEMPOB,rows,columns);
//    if(sat_array==0) { sat3_exiterror(Insufficient_Memory); return FALSE;}
//    for (i=0;i<rows;i++){
//       for (j=0;j<columns;j++) {
//    	   sat3_rarrayput_dbl( sat_array,i,j,array[i][j]);
//        }
//    }
//	retval=sat3_push(sat_array);
//	push_as_vector=0;
//    return retval;
//}
BOOL
sat_push_double_cvector(int n,double *rvector, double *ivector){
	int j;
	SAT_OBJECT sat_array;
    sat_array=sat3_createcarray(ALLOC_TEMPOB,n,0);
    if(sat_array==0){ sat3_exiterror(Insufficient_Memory); return FALSE;}
    for (j=0;j<n;j++) sat3_carrayput_dbl( sat_array,j,0,rvector[j], ivector[j]);
    sat3_push(sat_array);
    return TRUE;
}


//BOOL
//sat_push_double_cmatrix(int rows,int columns,double **rarray, double **iarray)
//{
//// NOTE: if push_as_vector=TRUE , it is assumed columns=0
//	int i,j, retval;
//    SAT_OBJECT sat_array;
//    if (push_as_vector) sat_array=sat3_createcarray(ALLOC_TEMPOB,rows,0);
//    else 		   		sat_array=sat3_createcarray(ALLOC_TEMPOB,rows,columns);
//    if(sat_array==0) { sat3_exiterror(Insufficient_Memory); return FALSE;}
//    for (i=0;i<rows;i++){
//       for (j=0;j<columns;j++) {
//    	   sat3_carrayput_dbl( sat_array,i,j,rarray[i][j], iarray[i][j]);
//        }
//    }
//	retval=sat3_push(sat_array);
//	push_as_vector=0;
//    return retval;
//}


double *
sat_create_pop_double_vector(int *n)
{
// double sat3_pop_dbl(0.0)
	SAT_OBJECT	eaddr;
int flag=0, rows=0,cols=0,j;
double *vector=0;

	if(sat3_depth()==0) sat3_exiterror(Too_Few_Arguments); //error: too few arguments
    eaddr= sat3_pick(1) ;
	if (!(flag=sat3_rarraysize(eaddr,&rows, &cols)))sat3_exiterror( Bad_Argument_Type );   //error: not an arry
	if ((cols))  sat3_exiterror( Invalid_Dimensions);
	if (!( vector=create_vector(rows))) sat3_exiterror(Insufficient_Memory);
	for (j=0;j<rows;j++) vector[j]=sat3_rarrayget_dbl( eaddr,j,0);
    sat3_drop(); //pop the vector from the stack
    *n=rows;
	return (vector);
}

//
//double **
//sat_create_pop_double_matrix(int *m,int *n)
//{
//// double sat3_pop_dbl(0.0)
//SAT_OBJECT	eaddr;
//int cols=0, rows=0,j;
//int flag,i;
//double **arry;
//    forced_to_matrix=0;
//	if(sat3_depth()==0) sat3_exiterror(Too_Few_Arguments); //error: too few arguments
//	eaddr= sat3_pick(1) ;
//	if (!(flag=sat3_rarraysize(eaddr,&rows, &cols)))sat3_exiterror( Bad_Argument_Type );   //error: not an arry
//	if(!(cols)) {cols=1;forced_to_matrix=1;}
//	if (!( arry=create_matrix2(rows,cols))) sat3_exiterror(Insufficient_Memory);
//
//for (i=0;i<rows;i++){
//			for (j=0;j<cols;j++){
//				arry[i][j]=sat3_rarrayget_dbl( eaddr,i,j);
//			}
//		}
//
//    sat3_drop(); //pop the arry from the stack
//    *m=rows;
//	*n=cols;
//	return arry;
//
//}

int *
create_int_vector(int m)
{
     // Dynamically allocate an n integer array
	int *list,i;
	if(!(list = (int *) calloc(m,sizeof(int)))){sat3_exiterror(Insufficient_Memory); return (0);}
	for (i=0;i<m;i++) {list[i]=0;}
	return (list);
}



double *
create_vector(int m)
{
     // Dynamically allocate an n vector
	double r=0.0;
	double *vec;
	if(!(vec = (double *) calloc(m,sizeof(double)))){sat3_exiterror(Insufficient_Memory); return (0);}
	const_vector(m,r,vec); //	for (i=0;i<m;i++) {vec[i]=r;}
	return (vec);
}

double **
create_matrix2(int m, int n)
{
     // Dynamically allocate an mxn
     //

	int i;
	const double r=0.0;
	double  **a;
    if(!(a = (double **)calloc(m,sizeof(double *)))) { sat3_exiterror(Insufficient_Memory);  return (0);}
    for (i=0;i<m;i++) {
		if (!(a[i] = (double *)calloc(n,sizeof(double)))){a[0]=0;sat3_exiterror(Insufficient_Memory); return (0);}
	}
	const_matrix(m,n,r,a); //	for (i=0;i<m;i++){for(j=0;j<n;j++){a[i][j]=r;}}
	return a;
}
 void
free_matrix2(int m,int n,double **a)    // actually only a list of separate vectors ***
{	// free matrix generated by create_matrix2
	int i;
	n=0;   // avoid warning
	for (i=0;i<m;i++){free(a[i]);}
	free(a);
}

int main()
{
//	const double eps = 1E-16, tol = 1E-32;	// used by the svd solver tol/eps =tiny

	int task_to_do = 0, retval = 0;

	task_to_do = sat3_pop_int(0);

	switch (task_to_do)
	{
////
////	case 13:					// fft
////		retval =do_four1();
////		break;
//
//	case 31:
//		retval = do_det();			// determinant
//		break;
//	case 32:
//		retval = do_inv();			// invert a
//		break;
//	case 33:
//		retval = do_solv( 0);		// solve ax=b
//		break;
//	case 34:
//		retval = do_solv( 1);		// solve transp(a)*x=b
//		break;
//	case 35:
//		retval = do_mult( 0);		// A=B*C
//		break;
//	case 36:
//		retval = do_mult( 1);		// A=transp(B)*C
//		break;
//	case 37:
//		retval = do_add(0 );		// A=B+C
//		break;
//	case 38:
//		retval = do_add( 1 );		// A=B-C
//		break;
//	case 39:
//		retval = do_eig(0 );		// eigenvector, eignvalues, input real matrix
//		break;
//	case 40:
//		retval = do_expm( );		// matrix exponential, input real matrix
//		break;
//	case 41:
//		retval = do_eig( 1);		// eigenvalues only, input real matrix
//		break;
//
//	case 42:
//		retval = do_gramschmidt();	// Gram-Schmidt orthogonalization, input real matrix
//		break;
//
//	case 43:
//		retval = do_choldecomp();	// LU<-A decomposition input real matrix
//		break;
//
//	case 44:
//		retval = do_geneig();		// Bz=lamCz, C pos definit
//		break;
//
//	case 45:
//		retval = do_choltransform();		// Bz=lamCz, C pos definit
//		break;
//
//	case 50:
//		retval = do_minimax();		// minimax polynom
//		retval=50;
//		break;
	case 0:
		retval = do_chebsolve(0);		// chebsolve, output real roots [-1..1] only
		break;
	case 1:
		retval = do_chebsolve(1);		// chebsolve, out put all roots, (real or complex)
		break;
//	case -4 ... 3:
//		retval = do_svd(task_to_do, eps, tol);
//		break;					//  0 : singular values only ; print s
////  case   1 :  retval=do_svd(task_to_do,big_double,eps,tol); break;                    //  1 : calculate u,v,s ; print u,v,s
////  case   2 :  retval=do_svd(task_to_do,big_double,eps,tol); break;                    //  2 : solve ax=b      ; print x
////  case   3 :  retval=do_svd(task_to_do,big_double,eps,tol); break;                    //  3 : solve ax=b       ; print u v s x
////  case  -1 : retval=do_svd(task_to_do,big_double,eps,tol); break;                 // -1 : singular values and u ; print s ,u
////  case  -2 : retval=do_svd(task_to_do,big_double,eps,tol); break;                 // -2 : singular values and v ; print s ,v
////  case  -3 : retval=do_svd(task_to_do,big_double,eps,tol); break;                 // -3 : internal use solve for singular values only, no print
////  case  -4 : retval=do_svd(task_to_do,big_double,eps,tol); break;                 // -4 : internal use solve for singular values,v special output
	}


	if (!(retval))
		goto normal_exit;
	if (retval > 0)
		goto normal_exit;
/* error messages at top level */
	switch (retval)
	{
	case 0:
		break;
	case -1:
		sat3_push_string("Interrupted"); // # 13F interrupted by user
		break;
	case -2:
		sat3_push_string("ERROR: Not implemented");  // #DE1B To be implemented
		break;
	case -3:	// error exit, message supplied through sat3_errorsto
		sat3_exiterror(retval);
		break;
	case -8:
		sat3_exiterror(Infinite_Result);  // #305 err number in HP
//		sat3_errorsto(Infinite_Result);  // #305 err number in HP
		break;
	case -9:
		sat3_exiterror(Invalid_Dimensions);	// #501 err number in HP
//		sat3_errorsto(Invalid_Dimensions);	// #501 err number in HP
		break;
	case -999:
		sat3_exiterror(Insufficient_Memory);  // #1 err number in HP
//		sat3_errorsto(Insufficient_Memory);  // #1 err number in HP
		break;
	case -99:
		break;					// error, message supplied by subroutine, stack has been cleaned for input
		/*else */
			sat3_push_string("ERROR: Internal error upper level");
	}
	//  reset speed and close hp49 stack
  normal_exit:
//	sat3_push_int_bint(abs(retval));
//	if((retval<0)) sat3_push_int_bint(minusone);
	return 0;
}


//int
//svdsolve(int m, int n, double **a, double *b, double **u,
//		 double **v, double *q, double *e, double *xx, double *t,
//		 int with_u, int with_v, int with_b, double eps, double tol)
//{
//// svd starts here
//
//// {
//
//	double r1;
//	int i, j, ii, jj;
//	int k, l = 0, l1, iter, retval = 0;
//	double c, f, g, h, s, x, y, z;
//
//	int pm;
//	double rmax;
//
//
////
//	if (m < n)
//	{
//		retval = -2;
//		goto exit_all;
//	}
//
///* Copy 'a' to 'u' , include padded zeros */
//	copy_matrix(m,n,u,a);
////	for (i = 0; i < m; i++) {	for (j = 0; j < n; j++) u[i][j] = a[i][j];}
///* Householder's reduction to bidiagonal form. */
//	g = x = 0.0;
//	for (i = 0; i < n; i++)
//	{
//		e[i] = g;
//		s = 0.0;
//		l = i + 1;
//		for (j = i; j < m; j++)
//			s += (u[j][i] * u[j][i]);
//		if (s < tol)
//			g = 0.0;
//		else
//		{
//			f = u[i][i];
//			g = (f < 0) ? sqrt(s) : -sqrt(s);
//			h = f * g - s;
//			u[i][i] = f - g;
//			for (j = l; j < n; j++)
//			{
//				s = 0.0;
//				for (k = i; k < m; k++)
//					s += (u[k][i] * u[k][j]);
//				f = s / h;
//				for (k = i; k < m; k++)
//					u[k][j] += (f * u[k][i]);
//			}					/* end j */
//		}						/* end s */
//		q[i] = g;
//		s = 0.0;
//		for (j = l; j < n; j++)
//			s += (u[i][j] * u[i][j]);
//		if (s < tol)
//			g = 0.0;
//		else
//		{
//			f = u[i][i + 1];
//			g = (f < 0) ? sqrt(s) : -sqrt(s);
//			h = f * g - s;
//			u[i][i + 1] = f - g;
//			for (j = l; j < n; j++)
//				e[j] = u[i][j] / h;
//			for (j = l; j < m; j++)
//			{
//				s = 0.0;
//				for (k = l; k < n; k++)
//					s += (u[j][k] * u[i][k]);
//				for (k = l; k < n; k++)
//					u[j][k] += (s * e[k]);
//			}					/* end j */
//		}						/* end s */
//		y = fabs(q[i]) + fabs(e[i]);
//		if (y > x)
//			x = y;
//	}							/* end i */
//
///* accumulation of right-hand transformations */
//	if (with_v)
//	{
//		for (i = n - 1; i >= 0; i--)
//		{
//			if (g != 0.0)
//			{
//				h = u[i][i + 1] * g;
//				for (j = l; j < n; j++)
//					v[j][i] = u[i][j] / h;
//				for (j = l; j < n; j++)
//				{
//					s = 0.0;
//					for (k = l; k < n; k++)
//						s += (u[i][k] * v[k][j]);
//					for (k = l; k < n; k++)
//						v[k][j] += (s * v[k][i]);
//
//				}				/* end j */
//			}					/* end g */
//			for (j = l; j < n; j++)
//				v[i][j] = v[j][i] = 0.0;
//			v[i][i] = 1.0;
//			g = e[i];
//			l = i;
//		}						/* end i */
//
//	}
//
//	/* end with_v, parens added for clarity */
//	/* accumulation of left-hand transformations */
//	if (with_u)
//	{
//		for (i = n; i < m; i++)
//		{
//			for (j = n; j < m; j++)
//				u[i][j] = 0.0;
//			u[i][i] = 1.0;
//		}
//	}
//	if (with_u)
//	{
//		for (i = n - 1; i >= 0; i--)
//		{
//			l = i + 1;
//			g = q[i];
//			for (j = l; j < m; j++)	/* upper limit was 'n' */
//				u[i][j] = 0.0;
//			if (g != 0.0)
//			{
//				h = u[i][i] * g;
//				for (j = l; j < m; j++)
//				{				/* upper limit was 'n' */
//					s = 0.0;
//					for (k = l; k < m; k++)
//						s += (u[k][i] * u[k][j]);
//					f = s / h;
//					for (k = i; k < m; k++)
//						u[k][j] += (f * u[k][i]);
//				}				/* end j */
//				for (j = i; j < m; j++)
//					u[j][i] /= g;
//			} /* end g */
//			else
//			{
//				for (j = i; j < m; j++)
//					u[j][i] = 0.0;
//			}
//			u[i][i] += 1.0;
//		}						/* end i */
//	}
//
//	/* end with_u, parens added for clarity */
//	/* diagonalization of the bidiagonal form */
//	eps *= x;
//	for (k = n - 1; k >= 0; k--)
//	{
//		iter = 0;
//	  test_f_splitting:
//		for (l = k; l >= 0; l--)
//		{
//			if (fabs(e[l]) <= eps)
//				goto test_f_convergence;
//			if (fabs(q[l - 1]) <= eps)
//				goto cancellation;
//		}						/* end l */
//
///* cancellation of e[l] if l > 0 */
//	  cancellation:
//		c = 0.0;
//		s = 1.0;
//		l1 = l - 1;
//		for (i = l; i <= k; i++)
//		{
//			f = s * e[i];
//			e[i] *= c;
//			if (fabs(f) <= eps)
//				goto test_f_convergence;
//			g = q[i];
//			h = q[i] = sqrt(f * f + g * g);
//			c = g / h;
//			s = -f / h;
//			if (with_u)
//			{
//				for (j = 0; j < m; j++)
//				{
//					y = u[j][l1];
//					z = u[j][i];
//					u[j][l1] = y * c + z * s;
//					u[j][i] = -y * s + z * c;
//				}				/* end j */
//			}					/* end with_u, parens added for clarity */
//		}						/* end i */
//	  test_f_convergence:
//		z = q[k];
//		if (l == k)
//			goto convergence;
//
///* shift from bottom 2x2 minor */
//		iter++;
//		if (iter > 30)
//		{
//			retval = k;
//			break;
//		}
//		x = q[l];
//		y = q[k - 1];
//		g = e[k - 1];
//		h = e[k];
//		f = ((y - z) * (y + z) + (g - h) * (g + h)) / (2 * h * y);
//		g = sqrt(f * f + 1.0);
//		f = ((x - z) * (x + z) +
//			 h * (y / ((f < 0) ? (f - g) : (f + g)) - h)) / x;
///* next QR transformation */
//		c = s = 1.0;
//		for (i = l + 1; i <= k; i++)
//		{
//			g = e[i];
//			y = q[i];
//			h = s * g;
//			g *= c;
//			e[i - 1] = z = sqrt(f * f + h * h);
//			c = f / z;
//			s = h / z;
//			f = x * c + g * s;
//			g = -x * s + g * c;
//			h = y * s;
//			y *= c;
//			if (with_v)
//			{
//				for (j = 0; j < n; j++)
//				{
//					x = v[j][i - 1];
//					z = v[j][i];
//					v[j][i - 1] = x * c + z * s;
//					v[j][i] = -x * s + z * c;
//				}				/* end j */
//			}					/* end with_v, parens added for clarity */
//			q[i - 1] = z = sqrt(f * f + h * h);
//			c = f / z;
//			s = h / z;
//			f = c * g + s * y;
//			x = -s * g + c * y;
//			if (with_u)
//			{
//				for (j = 0; j < m; j++)
//				{
//					y = u[j][i - 1];
//					z = u[j][i];
//					u[j][i - 1] = y * c + z * s;
//					u[j][i] = -y * s + z * c;
//				}				/* end j */
//			}					/* end with_u, parens added for clarity */
//		}						/* end i */
//		e[l] = 0.0;
//		e[k] = f;
//		q[k] = x;
//		goto test_f_splitting;
//	  convergence:
//		if (z < 0.0)
//		{
///* q[k] is made non-negative */
//			q[k] = -z;
//			if (with_u)
//			{
//				for (j = 0; j < m; j++)
//					u[j][k] = -u[j][k];
//			}					/* end with_u, added buy skai */
//			//      } /* end z */                    // skai
////          if (with_v) {
////              for (j=0;j<n;j++)
////                  v[j][k] = -v[j][k];
////          } /* end with_v, parens added for clarity */
//		}						/* end z */
//	}							/* end k */
//
////  return retval;
//// }
//
//
///* sort values and corresponding U V */
//	for (ii = 0; ii <= n - 2; ii++)
//	{
//		pm = ii;
//		rmax = 0.0;
//		for (jj = ii; jj < n; jj++)
//		{
//			if (rmax < q[jj])
//			{
//				pm = jj;
//				rmax = q[jj];
//			}
//		}
//		r1 = q[ii];
//		q[ii] = rmax;
//		q[pm] = r1;				// swap q
//		if (with_u)
//		{						// swap u
//			for (jj = 0; jj < m; jj++)
//			{
//				r1 = u[jj][ii];
//				u[jj][ii] = u[jj][pm];
//				u[jj][pm] = r1;
//			}
//		}
//		if (with_v)
//		{						// swap v
//			for (jj = 0; jj < n; jj++)
//			{
//				r1 = v[jj][ii];
//				v[jj][ii] = v[jj][pm];
//				v[jj][pm] = r1;
//			}
//		}
//	}
//
//
//// int svdbak(double *q,double **u,double **v,double *x,double *b)
//// {
//
////  int i,j;
//	if (with_b)
//	{
//		for (i = 0; i < n; i++)
//		{
//			t[i] = 0.0;
//			if (fabs(q[i]) > 1.0E-40)	/*  tol      */
//			{
//				for (j = 0; j < m; j++)
//					t[i] += (u[j][i] * b[j]);	/*   U'.b       */
//
//				t[i] /= q[i];	/*  (1/q).U'.b  */
//			}
//		}
//		for (i = 0; i < n; i++)
//		{
//			xx[i] = 0.0;
//			for (j = 0; j < n; j++)
//				xx[i] += (v[i][j] * t[j]);	/* V.(1/q).U'.b */
//		}
//	}
//  exit_all:
//	return (retval);
//}
//
//
//void							/* convolve double vectors  vec1*vec2 -> vec3 */
//convolve(int m, int n, double vec1[], double vec2[], double vec3[])
//{
//	int i, j;
//	double t;
//	for (i = 0; i < (m + n); i++)
//		vec3[i] = 0;
//	for (i = 0; i < m; i++)
//	{
//		t = vec1[i];
//		for (j = 0; j < n; j++)
//			vec3[i + j] += vec2[j] * t;
//	}
//}
//
//int								/* pop real vector from hp stack */
/*
pop_vector(double *vec)
{
	int i, n;
	n = sat3_pop_int(1);
	for (i = n - 1; i >= 0; i--)
		vec[i] = sat3_pop_dbl(0.0);
	return (n);
}
*/
// int								/* pop reals from hp stack into matrix, NB without indices */
/*
pop_matrix_reals(int m, int n, double **mat)
{
	int i, j;
	for (i = m - 1; i >= 0; i--)
	{
		for (j = n - 1; j >= 0; j--)
			mat[i][j] = sat3_pop_dbl(0.0);
	}
	return (m * n);
}
*/
//int *								/* pop integer list from hp stack */
//pop_list_create_zint( int *elements)
//{
//	int n,i, *l;
//	SAT_OBJECT mylist,position;
//	mylist=sat3_pop();
//	n=sat3_listcount(mylist);
//	l=create_int_vector(n);
//	position=sat3_listhead(mylist); // position POINTS TO THE HEAD
//
//	for (i=1;n+1; i++){
//		l[i]=sat3_convertzint_int(position);
//		position=sat3_listnext(position);  // position WILL POINT TO THE NEXT OBJECT, ON THE FIRST PASS WILL BE { 1 [position->] 2 3 }
//		}
//	*elements=n;
// 	return(l);
// 	}
//
//void							/* push list of integers as meta*/
//push_list(int n, int l[])
//{
//	int i;
//	SAT_OBJECT mylist=sat3_createlist(ALLOC_HEAP,1000);  // create the list, reserve 1000 nibbles
//	if(!mylist) sat3_exiterror(Insufficient_Memory);      // failed to create
//
//	SAT_OBJECT position=sat3_listhead(mylist);              // obtain the head of the list
//
//	for (i = 0; i < n; i++){
//		if(!sat3_createzint_int(position,l[i])) sat3_exiterror(Insufficient_Memory);
//		position=sat3_listnext(position);
//		}
//	if(!sat3_listclose(position)) sat3_exiterror(Insufficient_Memory);
//	sat3_push(mylist);
//}
//
//
//double							/* ||z-z0|| */
//rmsdiff(int iflag, int n, double z[], double z0[])
//{
//	int i;
//	double rsd = 0.0;
//	for (i = 0; i < n; i++)
//		rsd += square(z[i] - z0[i]);	// { r=z[i]-z0[i]; rsd+= r*r;}
//	if (iflag == 1)
//		rsd = sqrt(rsd);
//	return rsd;
//}
//
//double							/* ||z|| */
//fnorm2(int n, double z[])
//{
//	int i;
//	double s = 0.0;
//	for (i = 0; i < n; i++)
//		s += square(z[i]);		// *z[i];
//	return s;
//}
//
//double
//matnorm2(int m, int n, double **z)
//{
//	int i;
//	double sum2=0.0;
//	for (i=0;i<m;i++) sum2+= fnorm2(n, z[i]);
//	return sum2;
//}
//


void							/* copy vector vector of double */
copy_vector(int n, double *v0, double *v1)
{
	int i;
	for (i = 0; i < n; i++)
		v1[i] = v0[i];
}
//
//void							/* scale vector of double */
//scale_vector(int n, double scale, double *vec)
//{
//	int i;
//	for (i = 0; i < n; i++)
//		vec[i] *= scale;
//}
//
//void							/* scale matrix of double */
//scale_matrix(int m, int n, double scale, double **mat)
//{
//	int i;
//	for (i = 0; i < m; i++)
//		scale_vector(n, scale, mat[i]);
//}
//
//void							/* v0*scale+v1 ->v2, v0*scale+v1 ->v1 of double */
//scadd_vector(int n, double scale, double *v0, double *v1, double *v2)
//{
//	int i;
//	if (&v1[0]==&v2[0]){
//		if (scale==(-1.0)) { for (i = 0; i < n; i++) v1[i] -= v0[i];}
//		else 				{ for (i = 0; i < n; i++) v1[i] += v0[i] * scale;}
//	}
//	else {
//		if (scale==(-1.0)) {for (i = 0; i < n; i++) v2[i] = v1[i] - v0[i] ;}
//		else				{for (i = 0; i < n; i++) v2[i] = v1[i] + v0[i] * scale;}
//	};
//}
//
//void							/* v1+=v0*scale vector of double */
//scadd_matrix(int m, int n, double scale, double **m0, double **m1, double **m2)
//{
//	int i;
//	for (i = 0; i < m; i++)
//		scadd_vector(n,scale, m0[i], m1[i],m2[i]);
//}

// ----------
//int /* add matrix  c[m,n]=a[m,n]+b[m,n]   */
//do_add( int sign){
//	int m,n,mb,nb;
//	int retval=0;
//	double **a=0, **b=0;
//	if(!(b=sat_create_pop_double_matrix(&mb, &nb))) return (DO_ERROR_EXIT);
//	if(!(a=sat_create_pop_double_matrix(&m, &n))) 	return (DO_ERROR_EXIT);
//	if ((m!=mb)|| (n!=nb)) {sat3_exiterror(Invalid_Dimensions); retval=DO_ERROR_EXIT; goto exit_all; }		// "Error invalid dimensions"
//	add_matrix(m,n,a,b,a,sign);
//    exit_all:
//	free_matrix2(mb,nb,b);
//// NOTE: if push_as_vector=TRUE , it is assumed columns=0
//	if (!(retval)) {if (!(sat_push_double_matrix(m, n, a))) return (DO_ERROR_EXIT);}
//	free_matrix2(m,n,a);
//	return retval;
//}
//
//void /* a+sign*b -> c, a+sign*b -> a   */
//add_matrix( int m, int n, double **a, double **b, double **c,int sign)
//{
//	int i,j;
//	if (sign){ for(i=0;i<m;i++){for (j=0;j<n;j++) a[i][j]-=b[i][j];};}
//	else { for(i=0;i<m;i++){for (j=0;j<n;j++) a[i][j]+=b[i][j];};}
//
//}
//
// ----------

void							/* sort a based on b , vector of double */
sort_vector(int n, double *b, double *a, double *t)
{
	int i, j, p;
	double r0, r1;
	copy_vector(n, b, t);		//copy b to t, if t=b , b will be sorted too

	for (i = 0; i < n - 1; i++)
	{							//loop over vector
		p = i;
		r0 = 1e100;
		for (j = i; j < n; j++)
		{
			if (r0 > t[j])
			{
				p = j;
				r0 = t[j];
			}
		}						// find smallest
		r1 = t[i];
		t[i] = r0;
		t[p] = r1;
		r1 = a[i];
		a[i] = a[p];
		a[p] = r1;				// swap
	}
}

//
//int								/* svl and svd */
//do_svd(int task_to_do, double eps, double tol)
//{
//	int m, n=0, nm;
////	int m, n=0, nm, nmflag=0,i=0;
//	double **a, **u, *q, *e, **v, *b=0, *xx, *t;
//	a=sat_create_pop_double_matrix(&m, &n);
//	nm = max(m, n);
///*
//	if (nm>m){
//		nmflag=1;
//		u=create_matrix2(nm,nm);
//		copy_matrix(m,n, a, u);
////		Rename - the below need to be checked is it correct? ***
//		**t=**a; **a=**u; **u=**t;
//		for (i=0;i<nm;i++)*a[i]=*u[i];
//		for (i=m;i<nm;i++)a[i][i]=1.0;
//		free_matrix(m,n,u);
//	}
//*/
//	int retval = 0;
//	int p = 0;
//	int with_b = 0, with_u = 0, with_v = 0, with_s_output=0, with_uv_output = 0;
//	int dim_v = 1, dim_n = n, dim_m = nm;
//	switch (task_to_do)
//	{
//	case 0:
//		with_s_output = 1;
//		break;					//  0 : singular values only ; print s
//	case 1:
//		with_u = with_v = with_s_output = with_uv_output = 1;
//		break;					//  1 : calculate u,v,s ; print u,v,s
//	case 2:
//		with_u = with_v = with_b = 1;
//		break;					//  2 : solve ax=b      ; print x
//	case 3:
//		with_u = with_v = with_b = with_s_output = with_uv_output = 1;
//		break;					//  3 : solve ax=b       ; print u v s x
//	case -1:
//		with_s_output = with_u = with_uv_output = 1;
//		break;					// -1 : singular values and u ; print s ,u
//	case -2:
//		with_s_output = with_v = with_uv_output = 1;
//		break;					// -2 : singular values and v ; print s ,v
//	case -3:
//		with_u = with_v = 1;
//		break;					// -3 : internal use solve for singular values only, no print
//	case -4:
//		with_v = 1;
//		break;					// -4 : internal use solve for singular values,v special output
//	}
//	if (with_v)
//		dim_v = dim_n;
//	u=create_matrix2(dim_m,dim_m);
//	v=create_matrix2(dim_v,dim_v);
//
//	q=create_vector(dim_m);
//	e=create_vector(dim_m);
//	xx=create_vector(dim_m);
//	t=create_vector(dim_m);
//
//	if (with_b)
//	{
//		b=sat_create_pop_double_vector(&p);
///*
//		if (mnflag) {
//			copy_vector(q,b,m);
//			free b;
//			b*=q*;
//			q*= create_vector(mn);
//			}
//*/
//		if ((p != m) )	{ sat3_errorsto(Invalid_Dimensions); retval=DO_ERROR_EXIT;goto normal_exit;}  // error if dims of system incompatible
//	}
//	retval = svdsolve(m, n, a, b, u, v, q, e, xx, t, with_u, with_v, with_b, eps, tol);	//   solve system
//
//	if (with_uv_output && with_u) sat_push_double_matrix(m, m, u);	// push u
//	if (with_uv_output && with_v) sat_push_double_matrix(n, n, v);	// push V
//	if (with_s_output) sat_push_double_vector(n, q);				// push s
//	if (with_b)	sat_push_double_vector( n , xx); 					// push result
//
//
//	/* example of solving for initial v,w see zroot.pdf
//	   if (task_to_do==- 4) {
//	   r = 1.0/v[0][n-1];
//	   for (i=0;i<n;i+=2) sat3_push_dbl_real(v[i][n-1]*r); sat3_push_int_zint((n-1)/2+1);
//	   for (i=1;i<n;i+=2) sat3_push_dbl_real(v[i][n-1]*r); sat3_push_int_zint((n-1)/2);
//	   }
//	 */
//
//	/*  sat3_push_int_zint(retval); */// number of singular values < eps, 0 if all
//
//	goto normal_exit;
//  normal_exit:
//	free_matrix2(m, n, a);
//	free_matrix2(dim_m, dim_m, u);
//	free_matrix2(dim_v, dim_v, v);
//	free(q);
//	free(e);
//	if (with_b) free(b);
//	free(xx);
//	free(t);
//
//	return retval;
//
//
//
//}
//
//int								/* sum of list of integers */
//sum_integer_list(int n, int l[])
//{
//	int i, isum = 0;
//	for (i = 0; i < n; i++)
//		isum += l[i];
//	return isum;
//}
//
//void
//update_pointer(int m, int n, double **a){
//	int i;
//    for (i=1;i<m;i++) {
//        a[i] = a[i-1]+n*sizeof(double);
//	}
//}
/*
double **
create_matrix(int m, int n)
{
     // Dynamically allocate an mxn *continous* matrix
     // therefore you must use free_matrix

	const double r=0.0;
	double  **a;
    if(!(a = (double **)calloc(m,sizeof(double *)))) { sat3_errorsto(Insufficient_Memory); return (0);}
    if(!(a[0] = (double *)calloc(m*n,sizeof(double)))) {sat3_errorsto(Insufficient_Memory); return (0);}
	update_pointer(m, n, a);
	const_matrix(m,n,r,a); //	for (i=0;i<m;i++){for(j=0;j<n;j++){a[i][j]=r;}}
	return a;
}
*/
//
//void
//free_matrix(int m,int n,double **a)
//{
//	m=0;n=0;
//	free(a[0]);
//	free(a);
//}
//
//
//int /* det hp interface */
//do_det(){
//	int n,m, *ipvt;
//	int detFlag=10;
//	double det[2];
//	double **a, *work;
//	a=sat_create_pop_double_matrix(&m, &n);
//	if (!(m==n)) { sat3_errorsto( Invalid_Dimensions); return (DO_ERROR_EXIT); }
//	ipvt=create_int_vector(n);
//	work=create_vector(n);
//	dgefa(n,a,ipvt);
//	dgedi(n,a,ipvt,det,work,detFlag);
//	sat3_push_dbl_real(det[0]);
//	sat3_push_dbl_real(det[1]);
//	free_matrix2(m,n,a);
//	free(work);
//	free(ipvt);
//	return (0);
//}
//
//int /* inverse hp interface */
//do_inv(){
//	int m,n, *ipvt;
//	int detFlag=0,retval=0;
//	double det[2];
//	double **a, *work;
//	a=sat_create_pop_double_matrix(&m, &n);
//	if (!(m==n)) { sat3_errorsto( Invalid_Dimensions); return (DO_ERROR_EXIT); } // ***
//	ipvt=create_int_vector(n); // out of memory
//	work=create_vector(n); // out of memory
//	retval=dgefa(n, a, ipvt);
//	if (retval) { sat3_errorsto(Infinite_Result); retval=DO_ERROR_EXIT; goto exit_all;}		// "singular"
//	dgedi(n, a, ipvt, det, work, detFlag);
//	sat_push_double_matrix(m, n, a);
//exit_all:
//	free_matrix2(m,n,a);
//	free(work);free(ipvt);
//	return retval;
//}
//
//int /* solves x from ax=b */
//do_solv( int flagTransp){
//	int m,n,mb,nb, retval=0, *ipvt;
//	double **a, **b;
//	a=sat_create_pop_double_matrix(&m, &n);
//	b=sat_create_pop_double_matrix(&mb, &nb);
//	ipvt=create_int_vector(n);
//	if (n!=m || n!=mb) {sat3_errorsto(Invalid_Dimensions); retval=DO_ERROR_EXIT; goto exit_all; }		// "Error invalid dimensions"
//	if (dgefa(n, a, ipvt)) { sat3_errorsto(Infinite_Result); retval=DO_ERROR_EXIT; goto exit_all;}		// "singular"
//	dgesl(nb, n, a, ipvt, b, flagTransp);
//exit_all:
//	free_matrix2(m,n,a);
//	if ((forced_to_matrix )) push_as_vector=1;
//	if (!(retval)) {sat_push_double_matrix(mb, nb, b);}
//	free_matrix2(mb,nb,b);free(ipvt);
//	return retval;
//}
//
//int //  Valentin's  minimax  2009-09-24
//do_minimax(){
///*
//	int m,m2,n, n0, retval=0;
//	double **data, *pol, e, c;
//	e=sat3_pop_dbl(0.0);
//	n0=sat3_pop_dbl(1.0);
//	data=sat_create_pop_double_matrix(&m, &m2);
//	pol=create_vector(m+2);
//	if (n0>m+1 || m2!=2) {sat3_errorsto(Invalid_Dimensions); retval=DO_ERROR_EXIT; goto exit_all; }		// "Error invalid dimensions"
//    n=minimax(pol,data,&c,e,m,n0);
//    sat_push_double_vector(n,pol);
//exit_all:
//	free_matrix2(m,2,data);
//	free(pol);
//	return retval;
//*/
//	return 0;
//}
//
//
//
//
///* dgesl.c -- double precision solution of general matrix by
// *	      Gaussian elimination.
// *
// *	Solves the system A * X = B or TRANS(A) * X = B.
// *
// *	Operates on the LU decomposition (factorization)
// *	generated by dgefa.c or dgeco.c.
// *
// *	From "Linpack Users' Guide", Dongarra, et al.
// *	Translated from FORTRAN by C. Bond, 1994.
// */
//// #include <stdio.h>
//// #include "func.h"
//
//// #define max(a,b)	(((a) > (b)) ? (a) : (b))
//// #define min(a,b)	(((a) < (b)) ? (a) : (b))
//
//void /* backsubstitution */
//dgesl(int nb,int n, double **a /* [][n] */ ,int ipvt[],double **b /* [][nb] */,int job)
//{
//	double t;
//	int i,j,k,kb,l,nm1;
//
//	nm1 = n - 1;
//    if (job == 0) {
//
///* job = 0, solve a * x = b.
// * First solve l * y = b.
// */
//        for (j=0;j<nb;j++){
//			if (n > 0) {
//				for (k = 0; k < nm1; k++) {
//					l = ipvt[k];
//					t = b[l][j];
//					if (l != k) {
//						b[l][j] = b[k][j];
//						b[k][j] = t;
//					}
///*		saxpy(n-k,t,a(k+1,k),1,b(k+1),1); */
//					for (i=k+1;i < n;i++)
//						b[i][j] += (t * a[i][k]);
//				}
//			}
//
///* Now solve u * x = y. */
//
//			for (kb = 0; kb < n; kb++) {
//				k = n - kb-1;
//				b[k][j] /= a[k][k];
//				t = -b[k][j];
///*		saxpy(k-1,t,a(1,k),1,b(1),1); */
//				for (i = 0; i < k ; i++)
//					b[i][j] += (t * a[i][k]);
//			}
//		}
//        return;
//    }
///* job != 0, solve trans(a) * x = b.
// * First solve trans(u) * x = y.
// */
//    for (j=0;j<nb;j++){
//		for (k = 0; k < n; k++) {
///* 			t = ddot(k-1,a(1,k),1,b(1),1); */
//			t = 0;
//			for (i = 0; i < k; i++)
//				t += (a[i][k] * b[i][j]);
//			b[k][j] = (b[k][j] - t)/a[k][k];
//		}
///* Now solve trans(l) * x = y. */
//		if (n > 0) {
//			for (kb = 0; kb < nm1; kb++) {
//				k = n - 2 - kb;
///*			b[k] = b[k] + ddot(n-k,a(k+1,k),1,b(k+1),1); */
//				t = 0;
//				for (i = k+1;i < n; i++)
//					t += (a[i][k] * b[i][j]);
//				b[k][j] += t;
//				l = ipvt[k];
//				if (l != k) {
//					t = b[l][j];
//					b[l][j] = b[k][j];
//					b[k][j] = t;
//				}
//			}
//        }
//    }
//}
//
///* dgefa.c -- double precision solution of general matrix by
// *	      Gaussian elimination.
// *
// *	This routine performs the LU factorization. (You should
// *	use dgeco.c if you need a condition estimate.)
// *
// *	Follow this with a call to dgesl.c, which is the linear
// *	equation solver, or dgedi.c which computes the determinant
// *	and inverse.
// *
// *	From "Linpack Users' Guide", Dongarra, et al.
// *	Translated from FORTRAN by C. Bond, 1994.
// */
//// #include <stdio.h>
//// #include <math.h>
//
//// #define max(a,b)	(((a) > (b)) ? (a) : (b))
//// #define min(a,b)	(((a) < (b)) ? (a) : (b))
//
//int /* LU decomposition with pivot */
//dgefa(int n, double **a /* [][n] */, int ipvt[])
//{
//	double dmax,t;
//	int i,j,k,kp1,l,nm1, info=0;
//
//	nm1 = n - 1;
//    if (n > 0) {
//        for (k = 0; k < nm1; k++) {
//            kp1 = k + 1;
///* Find l = pivot index. */
//            dmax = fabs(a[k][k]);
//            l = k;
//            for (i = k+1; i < n; i++) {
//                if (fabs(a[i][k]) <= dmax) continue;
//                l = i;
//            }
//            ipvt[k] = l;
//
///* Zero pivot implies this column already triangularized. */
//            if (a[l][k] == 0.0) {
//                info = k;
//                continue;
//            }
//
///* Interchange if necessary. */
//            if (l != k) {
//                t = a[l][k];
//                a[l][k] = a[k][k];
//                a[k][k] = t;
//            }
//
///* Compute multipliers. */
//            if ((fabs(a[k][k])) <= 1e-30) { info=-8; goto exit_all;} // printf("\n!ERROR. Singular matrix.\n");
//            t = -1.0/a[k][k];
//            for (i = k+1; i < n; i++)
//                a[i][k] *= t;
//
///* Row elimination with column indexing. */
//            for (j = kp1; j < n; j++) {
//                t = a[l][j];
//                if (l != k) {
//                    a[l][j] = a[k][j];
//                    a[k][j] = t;
//                }
//                for (i = k+1; i < n; i++ )
//                    a[i][j] += (t * a[i][k]);
//            }
//        }
//    }
//	ipvt[n-1] = n-1;
//	if (a[n-1][n-1] == 0.0) info = n-1;
//exit_all:
//	return info;
//}
//
///* dgedi.c -- double precision solution of general matrix by
// *	      Gaussian elimination. computes determinant and
// *	      inverse of matrix (following dgeco or dgefa).
// *
// *	From "Linpack Users' Guide", Dongarra, et al.,
// */
//// #include <stdio.h>
//// #include <math.h>
//// #include "func.h"
//
//// #define max(a,b)	(((a) > (b)) ? (a) : (b))
//// #define min(a,b)	(((a) < (b)) ? (a) : (b))
//
//void /* inverse or determinant */
//dgedi(int n, double **a /* [][n] */,int ipvt[],double det[],double *work,int job)
//{
//	double const ten=10.0;
//	double t;
//	int i,j,k,kb,kp1,l,nm1;
//
///* Compute determinant. */
//    if ((job / 10) != 0) {
//        det[0] = 1.0;
//        det[1] = 0.0;
//        for (i = 0; i < n; i++) {
//            if (ipvt[i] != i) det[0] = -det[0];
//            det[0] *= a[i][i];
//            if (det[0] != 0.0) {
//                while (fabs(det[0]) < 1.0) {
//                    det[0] *= ten;
//                    det[1] -= 1.0;
//                }
//                while (fabs(det[0]) >= ten) {
//                    det[0] /= ten;
//                    det[1] += 1.0;
//                }
//            }
//        }
//    }
//
///* Compute inverse. */
//	if (job == 10) return;
//	for (k = 0; k < n; k++) {
//		a[k][k] = 1.0 / a[k][k];
//		t = -a[k][k];
//		/* dscal(k-1,t,a(1,k),1) */
//		for (i = 0; i < k; i++)
//			a[i][k] *= t;
//		kp1 = k + 1;
//        if ( n > kp1) {
//            for (j = kp1; j < n; j++) {
//                t = a[k][j];
//                a[k][j] = 0.0;
//			/* daxpy(k,t,a(1,k),1,a(1,j),1) */
//                for (i = 0; i < k+1; i++)
//                    a[i][j] += (t * a[i][k]);
//            }
//        }
//	}
//
///* Form inverse(u) * inverse(l) */
//	nm1 = n - 1;
//    if (n > 0) {
//        for (kb = 0; kb < nm1; kb++) {
//            k = n - kb - 2;
//            kp1 = k + 1;
//            for (i = kp1; i < n; i++) {
//                work[i] = a[i][k];
//                a[i][k] = 0.0;
//            }
//            for (j = kp1; j < n; j++) {
//                t = work[j];
//			/* daxpy(n,t,a(1,j),1,a(1,k),1) */
//                for (i = 0; i < n; i++)
//                    a[i][k] += (t * a[i][j]);
//            }
//            l = ipvt[k];
//            if (l != k) {
//			/* dswap(n,a(1,k),1,a(1,l),1) */
//                for (i = 0; i < n; i++) {
//                    t = a[i][k];
//                    a[i][k] = a[i][l];
//                    a[i][l] = t;
//                }
//            }
//        }
//    }
//}
//


//
//void    // copy matrix
//copy_matrix(int m, int n, double **out, double **in)
//{
//	int i,j;
//	for (i=0;i<m;i++){
//		for (j=0;j<n;j++) out[i][j]=in[i][j];
//	}
//}



void balanc(int n, double **a, int *lo, int *hi, double *scale)
{
/* This routine is a translation of the Algol procedure from
 * Handbook for Automatic Computation, vol. II, Linear Algebra,
 * by Wilkinson and Reinsch, Springer-Verlag.
 */
    double c,f,g,r,s,radix,b2,dtmp;
	int i,j,k,l, noconv;
//	int m;
	radix = 2.0;
	b2 = radix * radix;
	l = 0;
	k = n-1;

/* Search for rows isolating an eigenvalue and push them down. */
L1:
	if (k == 0) {
		*lo = l;
		*hi = k;
		return;
	}
	for (j = k; j >= 0; j--) {
		r = 0;
		for (i = 0; i <= k; i++) {
			if (i == j) continue;
			if (a[j][i] != 0.0) r = 1;
		}
		if (r == 0) {
			scale[k] = j;
			if (j != k) {
                for (i = 0; i <= k; i++) {
                    dtmp = a[i][j];
                    a[i][j] = a[i][k];
                    a[i][k] = dtmp;
                }
                for (i = l;i < n; i++) {
                    dtmp = a[j][i];
                    a[j][i] = a[k][i];
                    a[k][i] = dtmp;
                }
			}
			k--;
			goto L1;
		}
	}
/* Search for columns isolating an eigenvalue and push them left. */
L2:
	for (j = l; j <= k; j++) {
		c = 0;
		for (i = l; i <= k; i++) {
			if (i == j) continue;
			if (a[i][j] != 0.0) c = 1;
		}
		if (c == 0) {
			scale[l] = j;
			if (j != l) {
                for (i = 0; i <= k; i++) {
                    dtmp = a[i][j];
                    a[i][j] = a[i][l];
                    a[i][l] = dtmp;
                }
                for (i = l;i < n; i++) {
                    dtmp = a[j][i];
                    a[j][i] = a[l][i];
                    a[l][i] = dtmp;
                }
			}
			l++;
			goto L2;
		}
	}
/* Now balance the submatrix in rows l through k. */
	*lo = l;
	*hi = k;
	for (i = l; i <= k; i++)
		scale[i] = 1.0;
iteration:
	noconv = FALSE;
	for (i = l; i <= k; i++) {
		c = 0.0;
		r = 0.0;
		for (j = l; j <= k; j++) {
			if (j == i) continue;
            c += fabs(a[j][i]);
            r += fabs(a[i][j]);
		}
/* Guard against zero c or r due to underflow. (In FORTRAN version only!) */
		if ((c == 0.0) || (r == 0.0)) continue;
		g = r / radix;
		f = 1.0;
		s = c + r;
// L3:
		while (c < g) {
			f *= radix;
			c *= b2;
		}
		g = r * radix;
// L4:
		while (c >= g) {
			f /= radix;
			c /= b2;
		}
/* The preceding lines may be replaced by a machine language procedure
 * computing the exponent sig such that
 *	sqrt(r/(c * radix)) <= radix^sig < sqrt(r*radix)/c).
 * Now balance.
 */
 		if (((c + r)/f) < (0.95 * s)) {
 			g = 1.0 / f;
 			scale[i] *= f;
 			noconv = TRUE;
 			for (j = l; j < n; j++)
 				a[i][j] *= g;
 			for (j = 0; j <= k; j++)
 				a[j][i] *= f;
 		}
/* The j loops may be done by exponent modification in machine language. */
	}
	if (noconv) goto iteration;
	return;
}


// #include <stdio.h>
// #include "eispack.h"
// #define FALSE 0
// #define TRUE 1

void balbak(int n,int lo, int hi, double *scale,int m,double **z)
{
/* This routine is a translation of the Algol procedure from
 * Handbook for Automatic Computation, vol. II, Linear Algebra,
 * by Wilkinson and Reinsch, Springer-Verlag.
 */
	double s;
	int i,j,k,ii;

	m--;		/* m is handled as a FORTRAN index variable */
	if (m == 0)
		goto _200;
	if (hi == lo) goto _120;
	for(i = lo; i <= hi; i++) {
		s = scale[i];

/* Left hand eigenvectors are back transformed if the foregoing
 * statement is replaced by s = 1.0 / scale[i] ...
 */
 		for (j = 0; j <= m; j++)
 			z[i][j] *= s;
 	}
 _120:
 	for (ii = 0; ii < n; ii++) {
 		i = ii;
 		if ((i >= lo) && ( i <= hi))
 			goto skip_140;
 		if (i < lo)
 			i = lo - ii;
 		k = scale[i];
 		if (k == i)
 			goto skip_140;
 		for (j = 0;  j <= m; j++) {
 			s = z[i][j];
 			z[i][j] = z[k][j];
 			z[k][j] = s;
 		}
skip_140: ;
	}
_200:	return ;
}




// #include <stdio.h>
// #include "eispack.h"
// #define FALSE 0
// #define TRUE 1

//void elmbak(int n, int lo, int hi, double **a,int *intch,int m, double **z)
//{
///* This routine is a translation of the Algol procedure from
// * Handbook for Automatic Computation, vol. II, Linear Algebra,
// * by Wilkinson and Reinsch, Springer-Verlag.
// */
//	double x;
//	int i,j,kp1,la,mm,mp,mp1;
//
//	if (m == 0)
//		goto _200;
//	la = hi - 1;
//	kp1 = lo + 1;
//	if (la < kp1)
//		goto _200;
//	for (mm = kp1; mm <= hi; mm++) {
//		mp = lo + hi - mm;
//		mp1 = mp + 1;
//		for (i = mp1;i <= hi; i++) {
//			x = a[i][mp-1];
//			if (x == 0.0)
//				goto _110;
//			for (j = 0; j <= m; j++)
//				z[i][j] += (x * z[mp][j]);
//_110: ;
//		}
//		i = intch[mp];
//		if (i == mp)
//			goto _140;
//		for (j = 0; j <= m; j++) {
//			x = z[i][j];
//			z[i][j] = z[mp][j];
//			z[mp][j] = x;
//		}
//_140: ;
//	}
//_200:  return;
//}





// #include <stdio.h>
// #include <math.h>
// #include "eispack.h"
// #define FALSE 0
// #define TRUE 1

void elmhes(int n, double **a, int lo, int hi, int *intch)
{
/* This routine is a translation of the Algol procedure from
 * Handbook for Automatic Computation, vol. II, Linear Algebra,
 * by Wilkinson and Reinsch, Springer-Verlag.
 */
    double x,y,dtmp;
	int i,j,kp1,la,m,mm1,mp1;

	la = hi - 1;
	kp1 = lo + 1;

	if (la < kp1){goto finish;}
	for (m = kp1; m <= la; m++) {
		mm1 = m - 1;
		x = 0.0;
		i = m;
		for (j = m; j <= hi; j++) {
            if (fabs(a[j][mm1]) > fabs(x)){
				x = a[j][mm1];
				i = j;
			}
		}
		intch[m] = i;
		if (i != m){

/* Interchange rows and columns of array a. */
			for (j = mm1; j < n; j++) {
				dtmp = a[i][j];
				a[i][j] = a[m][j];
				a[m][j] = dtmp;
			}
			for (j = 0; j <= hi; j++){
				dtmp = a[j][i];
				a[j][i] = a[j][m];
				a[j][m] = dtmp;
			}
		}
		if (x != 0.0){
			mp1 = m + 1;
			for (i = mp1; i<=hi;i++){
				y = a[i][mm1];
				if ((y != 0.0) ){
					y /= x;
					a[i][mm1] = y;
					for (j = m; j < n; j++){
						a[i][j] -= y * a[m][j];}
					for (j = 0; j <=hi; j++){
						a[j][m] += y * a[j][i];}
				}
			} /* endfor  i */
		}
	} /* endfor m */
finish:
 return ;
}




// #include <stdio.h>
// #include "eispack.h"
// #define FALSE 0
#// define TRUE 1

void eltran(int n, int lo, int hi, double **a,int *intch,double **z)
{
/* This routine is a translation of the Algol procedure from
 * Handbook for Automatic Computation, vol. II, Linear Algebra,
 * by Wilkinson and Reinsch, Springer-Verlag.
 */
//	double x,y;
	int i,j,kl,mm,mp,mp1;
//	int m, la;
/* Initialize z to identity matrix. */
	for (j = 0; j < n; j++) {
		for (i = 0; i < n; i++)
			z[i][j] = 0.0;
		z[j][j] = 1.0;
	}
	kl = hi - lo - 1;
	if (kl < 1)
		goto _200;
	for (mm = 1; mm <= kl; mm++) {
		mp = hi - mm;
		mp1 = mp + 1;
		for (i = mp1; i <= hi; i++) {
			z[i][mp] = a[i][mp-1];
		}
		i = intch[mp];
		if (i == mp)
			goto _140;
		for (j = mp; j <= hi; j++) {
			z[mp][j] = z[i][j];
			z[i][j] = 0.0;
		}
		z[i][mp] = 1.0;
_140: ;
	}
_200: return ;
}




// #include <stdio.h>
// #include <math.h>
//#include "eispack.h"

// #define min(a,b)	(((a) < (b)) ? (a) : (b))
// #define max(a,b)	(((a) > (b)) ? (a) : (b))
// #define TRUE 1
// #define FALSE 0

/* This subroutine is a translation of the ALGOL procedure HQR,
 * Num. Math. 14, 219,231(1970) by Martin, Peters, and Wilkinson.
 * Handbook for Automatic Computation, vol. II - Linear Algebra,
 * pp. 357-391 (1971).
 *
 * The FORTRAN version from EISPACK (dated 1983) was used as a model,
 * warts and all.
 */

void hqr(int n,int lo,int hi,double **h,double *wr,double *wi,int *ierr)
{
/*
 *DECK HQR
      SUBROUTINE HQR (NM, N, LOW, IGH, H, WR, WI, IERR)
C***BEGIN PROLOGUE  HQR
C***PURPOSE  Compute the eigenvalues of a real upper Hessenberg matrix
C            using the QR method.
C***LIBRARY   SLATEC (EISPACK)
C***CATEGORY  D4C2B
C***TYPE      SINGLE PRECISION (HQR-S, COMQR-C)
C***KEYWORDS  EIGENVALUES, EIGENVECTORS, EISPACK
C***AUTHOR  Smith, B. T., et al.
C***DESCRIPTION
C
C     This subroutine is a translation of the ALGOL procedure HQR,
C     NUM. MATH. 14, 219-231(1970) by Martin, Peters, and Wilkinson.
C     HANDBOOK FOR AUTO. COMP., VOL.II-LINEAR ALGEBRA, 359-371(1971).
C
C     This subroutine finds the eigenvalues of a REAL
C     UPPER Hessenberg matrix by the QR method.
C
C     On INPUT
C
C        NM must be set to the row dimension of the two-dimensional
C          array parameter, H, as declared in the calling program
C          dimension statement.  NM is an INTEGER variable.
C
C        N is the order of the matrix H.  N is an INTEGER variable.
C          N must be less than or equal to NM.
C
C        LOW and IGH are two INTEGER variables determined by the
C          balancing subroutine  BALANC.  If  BALANC  has not been
C          used, set LOW=1 and IGH equal to the order of the matrix, N.
C
C        H contains the upper Hessenberg matrix.  Information about
C          the transformations used in the reduction to Hessenberg
C          form by  ELMHES  or  ORTHES, if performed, is stored
C          in the remaining triangle under the Hessenberg matrix.
C          H is a two-dimensional REAL array, dimensioned H(NM,N).
C
C     On OUTPUT
C
C        H has been destroyed.  Therefore, it must be saved before
C          calling  HQR  if subsequent calculation and back
C          transformation of eigenvectors is to be performed.
C
C        WR and WI contain the real and imaginary parts, respectively,
C          of the eigenvalues.  The eigenvalues are unordered except
C          that complex conjugate pairs of values appear consecutively
C          with the eigenvalue having the positive imaginary part first.
C          If an error exit is made, the eigenvalues should be correct
C          for indices IERR+1, IERR+2, ..., N.  WR and WI are one-
C          dimensional REAL arrays, dimensioned WR(N) and WI(N).
C
C        IERR is an INTEGER flag set to
C          Zero       for normal return,
C          J          if the J-th eigenvalue has not been
C                     determined after a total of 30*N iterations.
C                     The eigenvalues should be correct for indices
C                     IERR+1, IERR+2, ..., N.
C
C     Questions and comments should be directed to B. S. Garbow,
C     APPLIED MATHEMATICS DIVISION, ARGONNE NATIONAL LABORATORY
C     ------------------------------------------------------------------
C
C***REFERENCES  B. T. Smith, J. M. Boyle, J. J. Dongarra, B. S. Garbow,
C                 Y. Ikebe, V. C. Klema and C. B. Moler, Matrix Eigen-
C                 system Routines - EISPACK Guide, Springer-Verlag,
C                 1976.
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   760101  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890831  Modified array declarations.  (WRB)
C   890831  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  HQR
C


 */
	double norm,p=0.0,q=0.0,r=0.0,s,t,tst1,tst2,w,x,y,zz;

	int en,enm2,i,itn,its,j,k,l=0,ll,m=0,mm,mp2,na,notlas;

	*ierr = 0;
	norm = 0.0;
	k = 0;		/* Used for array indexing. FORTRAN version: k=1 */

/* Store roots isolated by balance. */
	for (i = 0; i < n; i++) {
		for (j = k; j < n; j++)
            norm += fabs(h[i][j]);
		k = i;
		if ((i >= lo) && (i <= hi))
			goto _50;
		wr[i] = h[i][i];
		wi[i] = 0.0;
_50: ;
	}
	en = hi;
	t = 0.0;
	itn = 30 * n;

/* Search for next eigenvalues. */
_60:
	if (en < lo) goto _1001;
	its = 0;
	na = en - 1;
	enm2 = na - 1;

/* Look for single small sub-diagonal element. */
_70:
	for (ll = lo;ll <= en; ll++) {
		l = en + lo - ll;
		if (l == lo) goto _100;
        s = fabs(h[l-1][l-1]) + fabs(h[l][l]);
		if (s == 0.0)
			s = norm;
		tst1 = s;
        tst2 = tst1 + fabs(h[l][l-1]);
		if (tst2 == tst1) goto _100;
	}

/* Form shift. */
_100:
	x = h[en][en];
	if (l == en)
		goto _270;
	y = h[na][na];
	w = h[en][na] * h[na][en];
	if (l == na)
		goto _280;
	if (itn == 0)
		goto _1000;
	if ((its != 10) && (its != 20))
		goto _130;

/* Form exceptional shift. */
	t += x;
	for (i = lo; i <= en; i++)
		h[i][i] -= x;
    s = fabs(h[en][na]) + fabs(h[na][enm2]);
	x = 0.75 * s;
	y = x;
	w = -0.4375 * s * s;
_130:
	its++;
	itn--;
/* Look for two consecutive small sub-diagonal elements. */
	for (mm = l;mm <= enm2; mm++) {
		m = enm2 + l - mm;
		zz = h[m][m];
		r = x - zz;
		s = y - zz;
		p = (r * s - w) / h[m+1][m] + h[m][m+1];
		q = h[m+1][m+1] - zz - r - s;
		r = h[m+2][m+1];
        s = fabs(p) + fabs(q) + fabs(r);
		p /= s;
		q /= s;
		r /= s;
		if (m == l)
			goto _150;
        tst1 = fabs(p) * (fabs(h[m-1][m-1]) + fabs(zz) +
            fabs(h[m+1][m+1]));
        tst2 = tst1 + fabs(h[m][m-1]) * (fabs(q) + fabs(r));
		if (tst2 == tst1)
			goto _150;
	}
_150:
	mp2 = m + 2;
	for (i = mp2; i <= en; i++) {
		h[i][i-2] = 0.0;
		if (i == mp2)
			goto _160;

		h[i][i-3] = 0.0;
_160: ;
	}
/* Double QR step involving rows l to en and columns m to en. */
	for (k = m; k <= na; k++) {
		notlas = (k != na);
		if (k == m)
			goto _170;
		p = h[k][k-1];
		q = h[k+1][k-1];
		r = 0.0;
		if (notlas)
			r = h[k+2][k-1];
        x = fabs(p) + fabs(q) + fabs(r);
		if (x == 0.0)
			goto _260;
		p /= x;
		q /= x;
		r /= x;
_170:
        s = sqrt(p*p+q*q+r*r);
        if (p < 0.0) s = -s;
		if (k == m)
			goto _180;
		h[k][k-1] = -s * x;
		goto _190;
_180:
		if (l != m)
			h[k][k-1] = -h[k][k-1];
_190:
		p += s;
		x = p / s;
		y = q / s;
		zz = r / s;
		q /= p;
		r /= p;
		if (notlas)
			goto _225;
/* Row modification. */
        for (j = k; j <= en; j++) {
			p = h[k][j] + q * h[k+1][j];
			h[k][j] -= (p * x);
			h[k+1][j] -= (p * y);
		}
		j = min(en,k+3);

/* Column modification. */
        for (i = l; i <= j; i++) {
			p = x * h[i][k] + y * h[i][k+1];
			h[i][k] -= p;
			h[i][k+1] -= (p * q);
		}
		goto _255;
_225:

/* Row modification. */
        for (j = k; j <= en; j++) {
			p = h[k][j] + q * h[k+1][j] + r * h[k+2][j];
			h[k][j] -= (p * x);
			h[k+1][j] -= (p * y);
			h[k+2][j] -= (p * zz);
		}
		j = min(en,k+3);

/* Column modification. */
        for (i = l; i <= j; i++) {
			p = x * h[i][k] + y * h[i][k+1] + zz * h[i][k+2];
			h[i][k] -= p;
			h[i][k+1] -= (p * q);
			h[i][k+2] -= (p * r);
		}
_255: ;
_260:;
	}
		goto _70;

/* One root found. */
_270:
		wr[en] = x + t;
		wi[en] = 0.0;
		en = na;
		goto _60;

/* Two roots found. */
_280:
		p = (y - x) / 2.0;
		q = p * p + w;
        zz = sqrt(fabs(q));
		x += t;
		if ( q < 0.0)
			goto _320;

/* Real pair. */
        zz = fabs(zz);
        if (p < 0.0) zz = -zz;
        zz += p;
		wr[na] = x + zz;
		wr[en] = wr[na];
		if (zz != 0.0)
			wr[en] = x - w / zz;
		wi[na] = 0.0;
		wi[en] = 0.0;
		goto _330;

/* Complex pair. */
_320:
		wr[na] = x + p;
		wr[en] = x + p;
		wi[na] = zz;
		wi[en] = -zz;
_330:
		en = enm2;
		goto _60;

/* Set error -- all eigenvalues have not converged after 30*n iterations. */
_1000:
	*ierr = en;
_1001:
	return;
}



// #include <stdio.h>
// #include <math.h>
// #include "eispack.h"

// #define min(a,b)	(((a) < (b)) ? (a) : (b))
// #define max(a,b)	(((a) > (b)) ? (a) : (b))
// #define TRUE 1
// #define FALSE 0

/* This subroutine is a translation of the ALGOL procedure HQR2,
 * Num. Math. 14, 219,231(1970) by Martin, Peters, and Wilkinson.
 * Handbook for Automatic Computation, vol. II - Linear Algebra,
 * pp. 357-391 (1971).
 *
 * FORTRAN version from EISPACK (dated 1983) was used as model.
 */

void cdiv(double ar,double ai,double br,double bi,double *cr,double *ci)
{
	double s,ars,ais,brs,bis;

    s = fabs(br) + fabs(bi);
	ars = ar / s;
	ais = ai / s;
	brs = br / s;
	bis = bi / s;
	s = brs * brs + bis * bis;
	*cr = (ars * brs + ais * bis) / s;
	*ci = (ais * brs - ars * bis) / s;
}

void hqr2(int n,int lo,int hi,double **h,double *wr,double *wi,
	double **z,int *ierr)
{
    double norm,p=0.0,q=0.0,r=0.0,ra,s=0.0,sa,t,tst1,tst2,vr,vi,w,x,y,zz=0.0,sgn;
	int en,enm2,i,ii,itn,its,j,jj,k,l=0,ll,m=0,mm,mp2,nn,na,notlas;

	*ierr = 0;
	norm = 0.0;
	k = 0;		/* Used for array indexing. FORTRAN version: k=1 */

/* Store roots isolated by balance, and compute matrix norm. */
	for (i = 0; i < n; i++) {
		for (j = k; j < n; j++)
            norm += fabs(h[i][j]);
		k = i;
		if ((i >= lo) && (i <= hi))
			goto _50;
		wr[i] = h[i][i];
		wi[i] = 0.0;
_50: ;
	}
	en = hi;
	t = 0.0;
	itn = 30 * n;

/* Search for next eigenvalues. */
_60:
	if (en < lo) goto _340;
	its = 0;
	na = en - 1;
	enm2 = na - 1;

/* Look for single small sub-diagonal element. */
_70:
	for (ll = lo;ll <= en; ll++) {
		l = en + lo - ll;
		if (l == lo) goto _100;
        s = fabs(h[l-1][l-1]) + fabs(h[l][l]);
		if (s == 0.0)
			s = norm;
		tst1 = s;
        tst2 = tst1 + fabs(h[l][l-1]);
		if (tst2 == tst1) goto _100;
	}

/* Form shift. */
_100:
	x = h[en][en];
	if (l == en)
		goto _270;
	y = h[na][na];
	w = h[en][na] * h[na][en];
	if (l == na)
		goto _280;
	if (itn == 0)
		goto _1000;
	if ((its != 10) && (its != 20))
		goto _130;

/* Form exceptional shift. */
	t += x;
	for (i = lo; i <= en; i++)
		h[i][i] -= x;
    s = fabs(h[en][na]) + fabs(h[na][enm2]);
	x = 0.75 * s;
	y = x;
	w = -0.4375 * s * s;
_130:
	its++;
	itn--;
/* Look for two consecutive small sub-diagonal elements. */
	for (mm = l;mm <= enm2; mm++) {
		m = enm2 + l - mm;
		zz = h[m][m];
		r = x - zz;
		s = y - zz;
		p = (r * s - w) / h[m+1][m] + h[m][m+1];
		q = h[m+1][m+1] - zz - r - s;
		r = h[m+2][m+1];
        s = fabs(p) + fabs(q) + fabs(r);
		p /= s;
		q /= s;
		r /= s;
		if (m == l)
			goto _150;
        tst1 = fabs(p) * (fabs(h[m-1][m-1]) + fabs(zz) +
            fabs(h[m+1][m+1]));
        tst2 = tst1 + fabs(h[m][m-1]) * (fabs(q) + fabs(r));
		if (tst2 == tst1)
			goto _150;
	}
_150:
	mp2 = m + 2;
	for (i = mp2; i <= en; i++) {
		h[i][i-2] = 0.0;
		if (i == mp2)
			goto _160;

		h[i][i-3] = 0.0;
_160: ;
	}
/* Double QR step involving rows l to en and columns m to en. */
	for (k = m; k <= na; k++) {
//		printf("%20.16g %20.16g %20.16g\n",h[0][0],h[0][1],h[0][2]);
//		printf("%20.16g %20.16g %20.16g\n",h[1][0],h[1][1],h[1][2]);
//		printf("%20.16g %20.16g %20.16g\n",h[2][0],h[2][1],h[2][2]);
		notlas = (k != na);
		if (k == m)
			goto _170;
		p = h[k][k-1];
		q = h[k+1][k-1];
		r = 0.0;
		if (notlas)
			r = h[k+2][k-1];
        x = fabs(p) + fabs(q) + fabs(r);
		if (x == 0.0)
			goto _260;
		p /= x;
		q /= x;
		r /= x;
_170:
        s = sqrt(p*p+q*q+r*r);
        sgn = (p<0)?-1:(p>0);
        s = sgn*sqrt(p*p+q*q+r*r);
		if (k == m)
			goto _180;
		h[k][k-1] = -s * x;
		goto _190;
_180:
		if (l != m)
			h[k][k-1] = -h[k][k-1];
_190:
		p += s;
		x = p / s;
		y = q / s;
		zz = r / s;
		q /= p;
		r /= p;
		if (notlas)
			goto _225;
/* Row modification. */
		for (j = k; j < n; j++) {
			p = h[k][j] + q * h[k+1][j];
			h[k][j] -= (p * x);
			h[k+1][j] -= (p * y);
		}
		j = min(en,k+3);

/* Column modification. */
		for (i = 0; i <= j; i++) {
			p = x * h[i][k] + y * h[i][k+1];
			h[i][k] -= p;
			h[i][k+1] -= (p * q);
		}
/* Accumulate transformations. */
		for (i = lo;i <= hi; i++) {
			p = x * z[i][k] + y * z[i][k+1];
			z[i][k] -= p;
			z[i][k+1] -= (p * q);
		}
		goto _255;
_225:

/* Row modification. */
		for (j = k; j < n; j++) {
			p = h[k][j] + q * h[k+1][j] + r * h[k+2][j];
			h[k][j] -= (p * x);
			h[k+1][j] -= (p * y);
			h[k+2][j] -= (p * zz);
		}
		j = min(en,k+3);

/* Column modification. */
		for (i = 0; i <= j; i++) {
			p = x * h[i][k] + y * h[i][k+1] + zz * h[i][k+2];
			h[i][k] -= p;
			h[i][k+1] -= (p * q);
			h[i][k+2] -= (p * r);
		}
/* Accumulate transformations. */
		for (i = lo; i <= hi; i++) {
			p = x * z[i][k] + y * z[i][k+1] + zz * z[i][k+2];
			z[i][k] -= p;
			z[i][k+1] -= (p * q);
			z[i][k+2] -= (p * r);
		}

_255:
_260: ;
	}
	goto _70;

/* One root found. */
_270:
	h[en][en] = x + t;
	wr[en] = h[en][en];
	wi[en] = 0.0;
	en = na;
	goto _60;

/* Two roots found. */
_280:
	p = (y - x) / 2.0;
	q = p * p + w;
    zz = sqrt(fabs(q));
	h[en][en] = x + t;
	x = h[en][en];
	h[na][na] = y + t;
	if ( q < 0.0)
		goto _320;

/* Real pair. */
    sgn = (p<0)?-1:(p>0);
    zz = p + sgn*zz;
	wr[na] = x + zz;
	wr[en] = wr[na];
	if (zz != 0.0)
		wr[en] = x - w / zz;
	wi[na] = 0.0;
	wi[en] = 0.0;
	x = h[en][na];
    s = fabs(x) + fabs(zz);
	p = x / s;
	q = zz / s;
	r = sqrt(p * p + q * q);
	p /= r;
	q /= r;

/* Row modification. */
	for (j = na;j < n; j++) {
		zz = h[na][j];
		h[na][j] = q * zz + p * h[en][j];
		h[en][j] = q * h[en][j] - p * zz;
	}

/* Column modification. */
	for (i = 0; i <= en; i++) {
		zz = h[i][na];
		h[i][na] = q * zz + p * h[i][en];
		h[i][en] = q * h[i][en] - p * zz;
	}
/* Accumulate transformations. */
	for (i = lo; i <= hi; i++) {
		zz = z[i][na];
		z[i][na] = q * zz + p * z[i][en];
		z[i][en] = q * z[i][en] - p * zz;
	}
	goto _330;

/* Complex pair. */
_320:
	wr[na] = x + p;
	wr[en] = x + p;
	wi[na] = zz;
	wi[en] = -zz;
_330:
	en = enm2;
	goto _60;

/* All roots found. Backsubstitute to find vectors of upper
 * triangular form. */
_340:
 	if (norm == 0.0)
		goto _1001;
	for (nn = 0; nn < n; nn++) {
		en = n - nn - 1;
		p = wr[en];
		q = wi[en];
		na = en - 1;
		if (q < 0.0) goto _710;
		if (q > 0.0) goto _800;

/* Real vector. */
		m = en;
		h[en][en] = 1.0;
		if (na < 0)
			goto _800;
		for (ii = 0; ii <= na; ii++) {
			i = en - ii - 1;
			w = h[i][i] - p;
			r = 0.0;
			for (j = m; j <= en; j++)
				r += (h[i][j] * h[j][en]);
			if (wi[i] >= 0.0)
				goto _630;
			zz = w;
			s = r;
			goto _700;
_630:
			m = i;
			if (wi[i] != 0.0)
				goto _640;
			t = w;
			if (t != 0.0)
				goto _635;
			tst1 = norm;
			t = tst1;
_632:
			t *= 0.01;
			tst2 = norm + t;
			if (tst2 > tst1)
				goto _632;
_635:
			h[i][en] = -r / t;
			goto _680;

/* Solve real equations. */
_640:
			x = h[i][i+1];
			y = h[i+1][i];
			q = (wr[i] - p) * (wr[i] - p) + wi[i] * wi[i];
			t = (x * s - zz * r) / q;
			h[i][en] = t;
            if (fabs(x) <= fabs(zz))
				goto _650;
			h[i+1][en] = (-r - w * t) / x;
			goto _680;
_650:
			h[i+1][en] = (-s - y * t) / zz;

/* Overflow control. */
_680:
            t = fabs(h[i][en]);
			if (t == 0.0)
				goto _700;
			tst1 = t;
			tst2 = tst1 + 1.0 / tst1;
			if (tst2 > tst1)
				goto _700;
			for (j = i; j <= en; j++)
				h[j][en] /= t;
_700: ;
		}
/* End real vector. */
		goto _800;

/* Complex vector. */
_710:
		m = na;

/* Last vector component chosen imaginary so that eigenvector matrix
 * is triangular. */
        if (fabs(h[en][na]) <= fabs(h[na][en]))
 			goto _720;
	 	h[na][na] = q / h[en][na];
 		h[na][en] = -(h[en][en] - p) / h[en][na];
 		goto _730;
_720:
		cdiv(0.0,-h[na][en],h[na][na]-p,q,&h[na][na],&h[na][en]);
_730:
		h[en][na] = 0.0;
		h[en][en] = 1.0;
		enm2 = na - 1;
		if (enm2 < 0)
			goto _800;
		for (ii = 0; ii <= enm2; ii++) {
			i = na - ii - 1;
			w = h[i][i] - p;
			ra = 0.0;
			sa = 0.0;
			for (j = m; j <= en; j++) {
				ra += (h[i][j] * h[j][na]);
				sa += (h[i][j] * h[j][en]);
			}
			if (wi[i] >= 0.0)
				goto _770;
			zz = w;
			r = ra;
			s = sa;
			goto _795;
_770:
			m = i;
			if (wi[i] != 0.0)
				goto _780;
			cdiv(-ra,-sa,w,q,&h[i][na],&h[i][en]);
			goto _790;

/* Solve complex equations. */
_780:
			x = h[i][i+1];
			y = h[i+1][i];
			vr = (wr[i] - p) * (wr[i] - p) + wi[i] * wi[i] - q * q;
			vi = (wr[i] - p) * 2.0 * q;
			if ((vr != 0.0) || (vi != 0.0))
				goto _784;
            tst1 = norm * (fabs(w) + fabs(q) + fabs(x) +
                fabs(y) + fabs(zz));
			vr = tst1;
_783:
			vr *= 0.01;
			tst2 = tst1 + vr;
			if (tst2 > tst1)
				goto _783;
_784:
			cdiv(x*r-zz*ra+q*sa,x*s-zz*sa-q*ra,vr,vi,&h[i][na],&h[i][en]);
            if (fabs(x) <= (fabs(zz) + fabs(q)))
				goto _785;
			h[i+1][na] = (-ra - w * h[i][na] + q * h[i][en]) / x;
			h[i+1][en] = (-sa - w * h[i][en] - q * h[i][na]) / x;
			goto _790;
_785:
			cdiv(-r-y*h[i][na],-s-y*h[i][en],zz,q,
				&h[i+1][na],&h[i+1][en]);

/* Overflow control. */
_790:
            t = max(fabs(h[i][na]),fabs(h[i][en]));
			if (t == 0.0)
					goto _795;
			tst1 = t;
			tst2 = tst1 + 1.0 / tst1;
			if (tst2 > tst1)
				goto _795;
			for (j = i; j <= en; j++) {
				h[j][na] /= t;
				h[j][en] /= t;
			}
_795: ;
		}
/* End complex vector. */
_800: ;
	}
/* End back substitution. Vectors of isolated roots. */
	for (i = 0; i < n; i++) {
		if ((i >= lo) && (i <= hi))
			goto _840;
		for (j = i; j < n; j++)
			z[i][j] = h[i][j];
_840: ;
	}

/* Multiply by transformation matrix to give vectors of original
 * full matrix. */
 	for (jj = lo; jj < n; jj++) {
		j = n + lo - jj - 1;
		m = min(j,hi);
		for (i = lo; i <= hi; i++) {
			zz = 0.0;
			for (k = lo; k <= m; k++)
				zz += (z[i][k] * h[k][j]);
			z[i][j] = zz;
 		}
 	}
 	goto _1001;
/* Set error -- all eigenvalues have not converged after 30*n iterations. */
_1000:
	*ierr = en;
_1001:
	return;
}



// #include <stdio.h>
// #include <math.h>
// #include "eispack.h"

// #define max(a,b)    (((a) > (b)) ? (a) : (b))

//
//void pnormwr(int n,double **z, double *wr, double *wi)
//{
//    double emax,ei,t,xi,xr,yi,yr,zi,zr;
//    int i,j,k;
//
//    for (i=0;i < n;i++) {
//        if (wi[i] == 0.0) {  /* eigenvector is real */
///* find max value in current column (eigenvector is column vector) */
//            emax = 0.0;
//            for (j = 0;j < n; j++) {
//                    emax = max(fabs(z[j][i]),emax);
//            } /* endfor j */
//            if (emax != 0.0) {
///* rescale eigenvector for max amplitude = unity */
//                emax = 1.0/emax;
//                for (j = 0;j < n;j++) {
//                    z[j][i] *= emax;
//                } /* endfor j */
//            } /* endif emax */
//        } /* endif wi[i] = 0.0 (real entry) */
//        else {  /* eigenvector is complex */
///* find max modulus and note location of corresponding element */
//            emax = 0.0;
//            k = 0;
//            for (j = 0;j < n; j++) {
//                xr = z[j][i];
//                yr = z[j][i+1];
//                xr = sqrt(xr*xr + yr*yr);
//                if (xr > emax) {
//                    emax = xr;
//                    k = j;
//                } /* endif xr */
//            } /* endfor j */
//            emax = z[k][i]; /* get re and im of element with max modulus */
//            ei = z[k][i+1];
//
//            for (j = 0;j < n; j++) {
///* rotate and scale each entry */
//                yr = emax;
//                yi = ei;
//                xr = z[j][i];
//                xi = z[j][i+1];
//                if (fabs(yr) > fabs(yi)) {
//                    t = yi / yr;
//                    yr += t * yi;
//                    zr = (xr + t * xi) / yr;
//                    zi = (xi - t * xr) / yr;
//                } /* endif */
//                else {
//                    t = yr / yi;
//                    yi += t * yr;
//                    zr = (t * xr + xi) / yi;
//                    zi = (t * xi - xr) / yi;
//                } /* endelse */
//                z[j][i] = zr;
//                z[j][i+1] = zi;
//            } /* endfor j */
//            i++;  /* complex value uses two columns */
//        } /* endelse wi[i] != 0.0 (complex entry) */
//    } /* endfor i */
////    printmat(z,"Normalized eigenvectors",n);
//	sat_push_double_matrix( n, n, z);
//	return ;
//}
//


/* tsthqr.c -- test path through elmhes, elmtrans, hqr
 * Solves for eigenvalues and eigenvectors of transition
 * matrix:
 *
 *            0 1 0 0
 *      M =   1 0 1 0
 *            1 0 0 1
 *            1 0 0 0
 */
// #include <stdio.h>
// #include <malloc.h>
// #include "eispack.h"

//int
//do_eig(int evlOnly)
//{
//	int retval,n,m;
//    int complexresult=0;
//	double **a, **v, *wr, *wi;
//	a=sat_create_pop_double_matrix(&m, &n);
//	v=create_matrix2(n,n);
//	wr=create_vector(n);
//	wi=create_vector(n);
//	if (n!=m) {sat3_errorsto(Invalid_Dimensions); retval=DO_ERROR_EXIT; goto exit_all; }		// "Error invalid dimensions"
//	complexresult=eig(a, v, wr, wi , m, n, evlOnly);
//
//
//	if (!(evlOnly)){
//		//  eigenvalues and all -vectors
//		if (!(complexresult))sat_push_double_matrix(n, n, v);
//		else 	sat_push_double_cmatrix(n, n, v, a);
//		}
//	if (!(complexresult))sat_push_double_vector(n, wr);
//	else sat_push_double_cvector(n, wr,wi);
//exit_all:
//	free_matrix2(n,n,a);
//	free_matrix2(n,n,v);
//    free(wr);
//    free(wi);
//	retval=0;
//	return retval;
//}
//

int
do_chebsolve(int Allroots)
{
// in: 2: vector of chebyshev coeffisients, 1:Allroots
// solves roots of chebyshev coeffisients by eigenvalues of companion matrix
// see "Approximation Theory and Approximation Practice, Lloyd N. Trefethen, Ch.18
// Allroots=0: return only real roots [-1,1]
	const int evlOnly=1;
	const double eps=1e-6;
	int retval,n,m,nc, i;
    int complexresult=0;
    double cn;
	double **a, **v, *wr, *wi, *c;
	c= sat_create_pop_double_vector(&nc);
	i= nc-1; while(c[i]==0.0) i--; nc=i+1;
	n=nc-1;
	a=create_matrix2(n,n);
	v=create_matrix2(n,n);
	wr=create_vector(n);
	wi=create_vector(n);
/*  build companion matrix for chebyshev  (column form) */
	for(i=0;i<(n-1);i++){ a[i][i+1]=0.5; a[i+1][i]=0.5; } a[n-2][n-1]=1.0;
	cn=-0.5/c[nc-1];
	for(i=0;i<n;i++){ a[i][0]=c[n-1-i]*cn; } a[1][0]+=0.5;
/* calculate all roots */
	complexresult=eig(a, v, wr, wi , n, n, evlOnly);

	if (!(Allroots)){
	//  pick out real roots [ -1,1]
		m=0;
		if (!(complexresult)) {for (i=0;i<n;i++){ if((wr[i]>=-1.000001)&&(wr[i]<=1.000001)){ wr[m]=wr[i];m++;}}}
		else { for(i=0;i<n;i++) {if ((wi[i]>(-eps))&&(wi[i]<eps)&&(wr[i]>=-1.000001)&&(wr[i]<=1.000001)){ wr[m]=wr[i];m++;}}}
		// TODO Newton-Rhapson 1 step to sort out spurious roots?

		if(m>1)sort_vector(m,wr,wi,wr);
		if (m>0)sat_push_double_vector(m, wr);
		sat3_push_int_real(m);
	}
	else
	{
		if (!(complexresult))sat_push_double_vector(n, wr);
		else sat_push_double_cvector(n, wr,wi);
		sat3_push_int_real(n);
	}
	free_matrix2(n,n,a);
	free_matrix2(n,n,v);
    free(wr);
    free(wi);
    free(c);
    retval=0;
	return retval;
}

int
eig(double **a, double **v, double *wr, double *wi ,int m, int n, int evlOnly)
//
//    this subroutine calls the recommended sequence of
//    subroutines from the eigensystem subroutine package (eispack)
//    to find the eigenvalues and eigenvectors (if desired)
//    of a real general matrix.
//
//    on input
//
//       nm  must be set to the row dimension of the two-dimensional
//       array parameters as declared in the calling program
//       dimension statement.
//
//       n  is the order of the matrix  a.
//
//       a  contains the real general matrix.
//
//       matz  is an integer variable set equal to zero if
//       only eigenvalues are desired.  otherwise it is set to
//       any non-zero integer for both eigenvalues and eigenvectors.
//
//    on output
//
//       wr  and  wi  contain the real and imaginary parts,
//       respectively, of the eigenvalues.  complex conjugate
//       pairs of eigenvalues appear consecutively with the
//       eigenvalue having the positive imaginary part first.
//
//       z  contains the real and imaginary parts of the eigenvectors
//       if matz is not zero.  if the j-th eigenvalue is real, the
//       j-th column of  z  contains its eigenvector.  if the j-th
//       eigenvalue is complex with positive imaginary part, the
//       j-th and (j+1)-th columns of  z  contain the real and
//       imaginary parts of its eigenvector.  the conjugate of this
//       vector is the eigenvector for the conjugate eigenvalue.
//
//       ierr  is an integer output variable set equal to an error
//          completion code described in the documentation for hqr
//          and hqr2.  the normal completion code is zero.
//
//       iv1  and  fv1  are temporary storage arrays.
//
//    questions and comments should be directed to burton s. garbow,
//    mathematics and computer science div, argonne national laboratory
//
//    this version dated august 1983.
//

{
	int retval,lo=0,hi, complexresult=0;
    int i,ierr;
	double *scale;
    int *inter;
    scale=create_vector(n);
	inter=create_int_vector(n);
	hi=n-1;
	for (i=0;i<n;i++){v[i][i] = 1.0;}

// nonsymmetric real, eigenvalues  : path : (balanc) elmhes eltran  hqr
// nonsymmetric real, eigenvalues+vect  : path : (balanc) elmhes eltran  hqr2 elmbac (balbac)
	if (evlOnly) {
	//  if only eigenvalues
		balanc(n, a,&lo, &hi, scale);
		elmhes(n, a,lo,hi,inter);
		hqr(n,lo,hi,a,wr,wi,&ierr);
		if (absmax(n,wi)) {complexresult=1;}
	}
	else{
	//  eigenvalues and all -vectors
		balanc(n, a,&lo, &hi, scale);
		elmhes(n, a,lo,hi,inter);
		eltran(n,lo,hi,a,inter,v);
		hqr2(n,lo,hi,a,wr,wi, v, &ierr);
		m=n;
		balbak(n,lo, hi,scale,m,v);
		if (absmax(n,wi)) {			// complex eigenvalues
			complexresult=1;
			split_matrix(n,n, wr, wi,v,a);
			}
	}
    free(inter);
	free(scale);
	retval=complexresult;
	return retval;
}

double      /* max abs value of vector */
absmax(int n , double *vec)
{	int i;
	double r=0.0,s;
	for (i=0;i<n;i++){
		s=fabs(vec[i]);
		r=max(s,r);
	}
	return r;
}

void
scale_col(int n, int j, double scale, double **mat)
{
	int i;
	double minus_one=-1.0;
	if ((scale=minus_one)){for (i=0;i<n;i++) mat[i][j]= -mat[i][j];}
	else {for (i=0;i<n;i++) mat[i][j]*= scale;}
}

void
copy_col(int n, double **matcopy, int jcopy, double **matorig, int jorig)
{
	int i;
	for (i=0;i<n;i++) matcopy[i][jcopy]= matorig[i][jorig];
}

void
split_matrix( int m, int n, double *wr, double *wi, double **v, double **a)
{
	int i, iflag=0;
	const_matrix(m,n, (0.0), a);
	for (i=0;i<n;i++){
		if (iflag) { iflag=0;}					// skip
		else
		{
			if ((wi[i]))
			{ // complex eigenvalue  					veci=(vi,vi+1) -> (vi, ai),
													//	veci+1=(vi,-vi+1) -> (vi+1, ai+1)
				copy_col(m,a,i,v,i+1); 					//	ai=vi+1
				copy_col(m,v,i+1,v,i);   					//	vi+1=vi
				copy_col(m,a,i+1,a,i);
				scale_col(m,i+1,(-1.0),a); 		//	ai+1=-ai
				iflag=1;
			}
		}
	}
}
//
//int /* multiply  c[m,nb]=a[m,n]xb[mb,nb]   */
//do_mult( int flagTransp){
//	int m,n,mb,nb,mc,nc,n2;
//	int retval=0;
//	double **a=0, **b=0, **c=0;
//	b=sat_create_pop_double_matrix(&mb, &nb);
//	push_as_vector=forced_to_matrix;
//	a=sat_create_pop_double_matrix(&m, &n);
//
//	mc=m;nc=nb;n2=n;
//	if ((flagTransp)){mc=n;n2=m;}
//	c=create_matrix2(mc,nc);
//	if (n2!=mb) {sat3_errorsto(Invalid_Dimensions); retval=DO_ERROR_EXIT; goto exit_all; }		// "Error invalid dimensions"
//
//    if((mult_matrix(m,n,mb,nb, a,b,c, flagTransp))) return(DO_ERROR_EXIT);
//exit_all:
//	free_matrix2(m,n,a);
//	free_matrix2(mb,nb,b);
//	if (!(retval)) {sat_push_double_matrix(mc, nc, c);}
//	free_matrix2(mc,nc,c);
//	return retval;
//}
//
//
//int	// a*b->c, at*b->c, a*c->c,  at*c->c, a*a->c, at*a->c,
//mult_matrix(int m,int n, int mb,int nb, double **a, double **b,double **c, int flagTransp)
//{
//	int i,j,k;
//	double sum, *tmp;
//	tmp=create_vector(mb);
//	for (k=0;k<nb;k++){
//		for  (j=0;j<mb;j++){	tmp[j]=b[j][k];}
//    	if (!(flagTransp)){	for  (i=0;i<m;i++){	c[i][k]=pracc(mb, i,a,tmp);}}	// c=axb
//		else{	for  (i=0;i<n;i++){	sum=0.0; for (j=0;j<mb;j++){ sum+=a[j][i]*tmp[j];} c[i][k]=sum;}} // c=transp(a)*b
//	}
//	free(tmp);
//	return (0);
//}
//
//double
//pracc(int n, int i, double **a, double *tmp)
//{
//	int j;
//	double sum=0.0;
//	for (j=0;j<n;j++) {sum+= a[i][j]*tmp[j];}
//
//	return sum;
//}
//
//
//int /* exp(m) by scaling, series and repeated squaring   */
//do_expm()
//{
//	int m,n;
//	int k=0,retval=0, i, h0=0,hn=1;
//	double f1=0.0,f0=0.0,r=1.0, s;
//	double **a, **bn, **b0, **tmp;
//	b0=sat_create_pop_double_matrix(&m, &n);
//
//
//	a=create_matrix2(m,n);
//	bn=create_matrix2(m,n);
//	tmp=create_matrix2(m,n);
//	if (n!=m) {sat3_errorsto(Invalid_Dimensions); retval=DO_ERROR_EXIT; goto exit_all; }		// "Error invalid dimensions"
//
//	for (i=0;i<m;i++) bn[i][i]=1.0;
//	copy_matrix(m,n,a,bn);
//	f1=sqrt(matnorm2(m,n,b0));
//
//	while(hn<(2*f1)) { h0++;hn*=2;}
//	s = 1.0/(hn);
//	scale_matrix(m,n,s,b0);
//
//	do{
////		clear_screen();printf("%5d %1.4e %1.4e\n", k, f0, f1);
//		if (keyb_isON()) {retval=-1;goto exit_all;}	//abort if ON pressed
//
//		k++;
//		r=r/k;
//		if(mult_matrix(m,n,m,n, bn,b0,tmp, (0))) return(DO_ERROR_EXIT);
//		copy_matrix( m,n,bn,tmp);		//
//		scadd_matrix( m,n,r, bn, a,a);	// r*bn+a->a
//		f0=f1;
//		f1=sqrt(matnorm2(m,n,a));
//		}
//		while (f0 != f1);
//	for(i=0;i<h0;i++){
//		if (keyb_isON()) {retval=-1;goto exit_all;}	//abort if ON pressed
//		if (mult_matrix(m,n,m,n, a,a,tmp, (0))) return(DO_ERROR_EXIT);
//		copy_matrix( m,n,a,tmp);		//
//		}
//
//exit_all:
//	free_matrix2(m,n,tmp);
//	free_matrix2(m,n,b0);
//	free_matrix2(m,n,bn);
//	if(!retval){sat_push_double_matrix(m, n, a);}
//	free_matrix2(m,n,a);
//	return retval;
//}
//int do_gramschmidt()
//{
//	int m,n;
//	int retval=0, i,j;
//	double f1=0;
//	double **a, *b, *tmp;
//	a=sat_create_pop_double_matrix(&m, &n);
//	b=create_vector(m);
//	tmp=create_vector(m);
//
//	if (n>m) {sat3_errorsto(Invalid_Dimensions); retval=DO_ERROR_EXIT; goto exit_all; }		// "Error invalid dimensions"
//
//	for (j=0;j<n;j++){
//		getcolvector(a,b,j,m);
//		f1=1.0/sqrt(fnorm2(m,b));
//		scale_vector(m,f1,b);
//		for(i=j+1;i<n; i++){
//			getcolvector(a,tmp,i,m);
//			f1= -(dotvector(f1,b,tmp,m));
//			scadd_vector(m,f1,b,tmp,tmp); // tmp[]= tmp[]-f1*b[];
//			putcolvector(a,tmp,i,m);
//		}
//		putcolvector(a,b,j,m);
//	}
//
//
//
//exit_all:
//	if(!retval){sat_push_double_matrix(m, n, a);}
//	free_matrix2(m,n,a);
//	free(tmp);
//	free(b);
//	return retval;
//}
//double dotvector(double f, double *a, double *b, int m){
//	int i;
//	f=0;
//	for (i=0;i<m;i++) f+=a[i]*b[i];
//	return f;
//}
//
//double *getcolvector(double **a, double *b, int k, int m){
//	int i;
//	for (i=0;i<m;i++) b[i]=a[i][k];
//	return b;
//}
//double **putcolvector(double **a, double *b, int k, int m){
//	int i;
//	for (i=0;i<m;i++) a[i][k]=b[i];
//	return a;
//}
//
///*
//int
//do_four1()
//{
//	int n0,n, nn, isign=0, retval=0;
//	n = sat3_pop_int(1);	// size of polynom, degree+1
//    if (n>0) { isign=1;}
//	else {n=-n; isign=-1;}	// inverse fft
//	nn=1;
//	while(nn<n){nn*=2;}
//	n=nn;
//	nn=2*n;    // real+im
//	double *data;
//	data=create_vector(nn);	if (!(data)){retval=-999;return retval;}
//	n0 = pop_vector(data);	//
//	four1(data, n, isign);
//	if (isign<0) scale_vector( (1.0/n),nn,data);
//	retval=push_vector(nn, data);
//	free(data);
//	return retval;
//}
//
//
//
//#define SWAP(a,b) tempr=(a);(a)=(b);(b)=tempr
//
//void
//four1(double data[], unsigned long nn, int isign)
//// Replaces data[1..2*nn] by its discrete Fourier transform, if isign is input as 1;
//// or replaces data[1..2*nn] by nn times its inverse discrete Fourier transform, if isign is input as -1.
//// data is a complex array of length nn or, equivalently, a real array of length 2*nn. nn MUST
//// be an integer power of 2 (this is not checked for!).
//{
//	unsigned long n,mmax,m,j,istep,i;
//	double wtemp,wr,wpr,wpi,wi,theta;  // Double precision for the trigonometfloat
//	double tempr,tempi;  // ric recurrences.
//	n=nn << 1;
//	j=1;
//	for (i=1;i<n;i+=2) {  // This is the bit-reversal section of the
//		if (j > i) { 			// routine.
//			SWAP(data[j],data[i]); // Exchange the two complex numbers.
//			SWAP(data[j+1],data[i+1]);
//		}
//		m=nn;
//		while (m >= 2 && j > m) {
//			j -= m;
//			m >>= 1;
//		}
//		j += m;
//	}
//// Here begins the Danielson-Lanczos section of the routine.
//	mmax=2;
//	while (n > mmax) { // Outer loop executed log2 nn times.
//		istep=mmax << 1;
//		theta=isign*(6.28318530717959/mmax);  // Initialize the trigonometric recurrence.
//		wtemp=sin(0.5*theta);
//		wpr = -2.0*wtemp*wtemp;
//		wpi=sin(theta);
//		wr=1.0;
//		wi=0.0;
//		for (m=1;m<mmax;m+=2) { // Here are the two nested inner loops.
//			for (i=m;i<=n;i+=istep) {
//				j=i+mmax; // This is the Danielson-Lanczos formula
//				tempr=wr*data[j]-wi*data[j+1];
//				tempi=wr*data[j+1]+wi*data[j];
//				data[j]=data[i]-tempr;
//				data[j+1]=data[i+1]-tempi;
//				data[i] += tempr;
//				data[i+1] += tempi;
//			}
//			wr=(wtemp=wr)*wpr-wi*wpi+wr;  // Trigonometric recurrence.
//			wi=wi*wpr+wtemp*wpi+wi;
//		}
//		mmax=istep;
//	}
//}
//*/
//double
//gcd(double v, double w)
//{
//	double r,u,t;
//	u=abs(v);
//	r=abs(w);
//	if (u<r) {t=u;u=r;r=t;}
//
//	do
//	{
//		t=r;
//		r=u-r*floor(u/r);
//		u=r;
//	}
//	while((r));
//	sat3_push_dbl_real(u);
//return u;
//}
/*
int minimax(double *pol, double **data, double *c, double e,int m, int n)
// * minimax polynom iteration
// * Valentin's minimax
//  pol : current minimax polynom, allocated size m+1, for worst case
//	data: [x,y], dim {m,2} in Valentin's program designated z[m] and y[m]
//	c	: max absoulute error of (pol(x)-y)
//	e	: allowable error
//	m	: dimension of data
//	n	: initial size of pol  (increases if necessary)

{
	const int w=1;
	int nsys, ll, i=0, j, t;
	int finish_flag=0;
	double err=0.0,h, k, p, q, r;
	double abs_err, abs_r;
	double *a, *u, *v;
	const double b=0.001;
	c=&err;
	n--;
	do
	{
		n++;
		clear_screen(); printf( "n %i3", i);
		p=data[0][0];
		q=data[0][1];
		nsys=n+2;
		ll=nsys-1;
		a=create_vector(nsys);
		u=create_vector(nsys);
		v=create_vector(nsys);
		for(i=0;i<nsys; i++){ j=i*(m-1)/ll; u[i]=data[j][0];v[i]=data[j][1];}
//      create and solve system, find best tuple
		while (!finish_flag)
		{
			spolmm(data,a,nsys);
			h=fabs(a[0]);
			t=0;
			err=abs_err=0.0;
			for(i=0;i<m;i++){
				r=fnf(a, data[i][0],ll) - data[i][1];
				abs_r=fabs(r);
				if (abs_r>abs_err){err=r; abs_err=abs_r;t=i;}
				}
			k=data[t][0];
		 	if (n==m-1||err==0.0) finish_flag=1; else finish_flag=( fabs(fabs(h/err)-1)<b|| (h==p && err==q));
			if(finish_flag) break;
			p=h;
			q=err;
			if (u[0]<k && k <u[ll]){
			 	i=0;
			    while(u[i++]>k);
			    if (fns(pol, data[i][0],data[i][1],nsys)!=fsign(err)) i--;
			    u[i]=k;
			    v[i]=data[t][1];
			}
			else if (k>=u[ll]){
	    	   	if (fns(pol, data[ll][0],data[ll][1],nsys)!=fsign(err)){
					for (i=0;i<ll;i++){ u[i]=u[i+1]; v[i]=v[i+1];}
   				}
			    u[ll]=k;
			    v[ll]=data[t][1];
			}
			else{
				if (fns(pol, data[0][0], data[0][1], nsys)!=fsign(err)){
					for (i=ll;i>0;i--){ u[i]=u[i-1]; v[i]=v[i-1];}
 				}
 				u[0]=k;
			    v[0]=data[t][1];
			}
			printf("/n h=  %f3, H= %f3 in %f ", h, err, k);
			WAIT_CANCEL;
		}  // next tuple
 		sat3_push_int_real(m);
 		sat3_push_dbl_real(err);
  		sat_push_double_vector(nsys, a);
  		free(a);free(u);free(v);
	}
	while ( !(e<0 || fabs(err)<e ||n==m-1));    // do-while finished->final result

//    for (i=0;i<n;i++) pol[i]=a[i+1];
//	free(u);
//	free(v);
//	free(a);

//	// Push result to stack as list of { m err pol }
//	// LIST CREATION: EXISTING OBJECTS CREATION METHOD
//	SAT_OBJECT sat_array;
//  sat_array=sat3_createrarray(ALLOC_TEMPOB,n,0);
//	if(!sat_array){ sat3_exiterror(Insufficient_Memory); return FALSE;}
//	for (i=0;i<n;i++) sat3_rarrayput_dbl( sat_array,i,0,pol[i]);
//
//	SAT_OBJECT mylist=sat3_createlist(ALLOC_HEAP,1000);  // create the list on the C heap and reserve 1000 nibbles
//	SAT_OBJECT sat_m=sat3_createreal_int(ALLOC_HEAP,m);
//	SAT_OBJECT sat_err=sat3_createreal_dbl(ALLOC_HEAP,err);
//	if(!mylist || !sat_m || !sat_err ) { sat3_exiterror(Insufficient_Memory); return FALSE;};             // check for failure
//
//	if(!sat3_listappend(mylist,sat_m)) exit(0);          // append the number, check for failure
//	if(!sat3_listappend(mylist,sat_err)) exit(0);          // append the number, check for failure
//	if(!sat3_listappend(mylist,sat_array)) exit(0);          // append the number, check for failure
//    sat3_push(mylist);
//
//	sat3_free(sat_m);
//	sat3_free(sat_err);
//	sat3_free(sat_array);

	return(n);
}
*/
/*
int spolmm(double **data, double *a,int n)
{
	int i,j,retval, *ipvt,sgn=1;
	double z,zn, **work, **mat;
	ipvt=create_int_vector(n);
	mat=create_matrix2(n,n);
	work=create_matrix2(n,1);
	for (i=0; i<n;i++){
		work[i][0]=data[n][1];
		sgn*=-1;
		zn=1.0;
		z=data[i][0];  // x[i]
		mat[i][0]=sgn;
		mat[i][1]=1.0;
		for (j=2;j<n;j++){
			zn*=z;
			mat[i][j]=zn;
			}
		}
	if (dgefa(n, mat, ipvt)) { sat3_errorsto(Infinite_Result); retval=DO_ERROR_EXIT; goto exit_spolmm;}		// "singular"
	dgesl(1, n, mat, ipvt, work, 0);
	for (i=0; i<n;i++)a[i]=work[i][0];
exit_spolmm:
	free_matrix2(n,n, mat);
	free_matrix2(n,1, work);
	free(ipvt);
	return (retval);
}
*/
/*
double fnf(double *pol, double x, int n)
{   int i;
    double r;
    r=0.0;for (i=1; i<n; i++) r=r*x+pol[i];
 return (r);
}
*/
/*
double fns(double *pol, double xi, double yi, int n)
{
    double r;
    r=fnf(pol,xi,n)-yi;
 	r=fsign(r);
 return (r);
}
int fsign( double x){
int i=0;
if (x>0) i=1;
if (x<0) i=-1;
return(i);
}
*/
//double  **transp( int m, double **L)
//// transpose square real matrix
//{	int i,j;
//	double tempr;
//	for(i=1;i<m;i++){
//		for (j=0;j<i;j++){
//			SWAP(L[j][i],L[i][j]);
////			tempr=L[j][i];
////			L[j][i]=L[i][j]);
////			L[i][j]=tempr;
//		}
//	}
//	return L;
//}
//int do_choldecomp(){
//	int m,n;
//	int retval=0;
//	double **a, *work;
//	a=sat_create_pop_double_matrix(&m, &n);
//	if (!(m==n)) { sat3_errorsto( Invalid_Dimensions); return (DO_ERROR_EXIT); } // ***
//	work=create_vector(n); // out of memory
//	retval=choldecomp(n, a, work);
//	if (retval) { retval=DO_ERROR_EXIT; goto exit_all;}		// "singular"
//	sat_push_double_matrix(m, n, a);
//exit_all:
//	free_matrix2(m,n,a);
//	free(work);
//	return retval;
//}
//
//int choldecomp(int n, double **L, double *w)
///*
//Inputs:
//	N, integer
//	A, N x N symmetric ( accesses only lower part )
//Returns:
//	L, N x N matrix, Upper-decomposed, lower initial, initial diagonal in w
//*/
//{	int i,j,k;
//	double s;
//	for(j=0;j<n;j++) w[j]=L[j][j];
//	// transpose
//	transp(n,L); // we will now only be accessing values on upper part only
//
//	for(j=0;j<n;j++){ // For j = 1 To n
//		s = 0.0;
//		for (k=0;k<j;k++) s += square( L[j][k]);  // accesses lower
//
//		L[j][j] = w[j] - s;
//		if (L[j][j] <= 0) return (Infinite_Result);
//		L[j][j] = sqrt(L[j][j]);
//		for(i=j+1;i<n;i++) { // For i = j + 1 To n
//			s = 0.0;
//			for (k=0;k<j;k++) s+= + L[i][k] * L[j][k];  // accesses  L*L
//			L[i][j] = (L[j][i] - s) / L[j][j]; // skai (A[i][j]-s)/L[j][j] // access U = L ***
//		} //Next i
//	} //Next j
//// transpose back to get cholesky part in upper and original in lower
//	transp(n,L);
//	return (0);
///* End of cholesky.c */
//}
///*     Bz=lamCz, C is symmetric nondefinit general eigenvalue problem */
//int do_geneig(){
//	int n,m, doRms=1;
//	double rms;
//	double **b, **c, *vr,*vi, **b_tmp=0, **c_tmp=0, **z_tmp=0;
////	sat3_peek(SAT_ADDR,)
//	c=sat_create_pop_double_matrix(&m, &n);
//	b=sat_create_pop_double_matrix(&m, &n);
//	if (!(m==n)) { sat3_errorsto( Invalid_Dimensions); return (DO_ERROR_EXIT); } // ***
//	if(m<BIG_ARRAY)b_tmp=create_matrix2(m,m); // only used if doRms
//	if(m<BIG_ARRAY)c_tmp=create_matrix2(m,m); // only used if doRms
//	if(m<BIG_ARRAY)z_tmp=create_matrix2(m,m);
//	vr=create_vector(n);
//	vi=create_vector(n);
//	rms=geneig(b,c,vr,vi,b_tmp,  c_tmp,z_tmp,m, doRms);
//	if (b_tmp)free_matrix2(m,m,b_tmp);
//	if (c_tmp)free_matrix2(m,m,c_tmp);
//	if (z_tmp)free_matrix2(m,m,z_tmp);
//	free_matrix2(m,n,c);
//	// if (retval==1=Complex) sat_push_double_cmatrix()
//    if (rms>=0)	sat_push_double_matrix(m, n, b);
//    free_matrix2(m,n,b);
//    if (rms>=0)	sat_push_double_vector(n, vr);
//    sat3_push_dbl_real(rms);
//    free(vr);
//	free(vi);
//	if (rms<0)sat3_exiterror(SATERR_BADARGVALUE);  //nonsymmetric or imagineer eigenvalues
//	return (0);
//}
//
//
//double geneig(double **b, double **c, double *zr,double *zi,
//		double **b_tmp, double **c_tmp, double **z_tmp,int m, int doRms){
//	// Bz=lamCz, C pos definit
//// intent: in/out: b assumed symmetric, out eigenvectors
////			in: c is assumed symmetric, positiv definit access only lower part,
////             process overwrites U of c
////			out: zr real eigenvalues
//// doRms=TRUE, explicitly calculate RMS, assumes that c is symmetric on imput
//	int retval,complexresult=0, evlOnly=FALSE, ierr=0;
//	double rms=0;
//	/* save a copy of b and c on sd-card */
//	if (doRms){if(!(b_tmp))ierr=write_matrix_to_SD(b,m,m,"b.dat");else copy_matrix(m,m,b_tmp,b);};
//	if (doRms){if(!(c_tmp))ierr=write_matrix_to_SD(c,m,m,"c.dat");else copy_matrix(m,m,c_tmp,c);};
//
//	/* transform to special eigenvalue problem */
//	if(choldecomp(m, c, zr))return(-1.0);  // choldecomp in upper , original in lower, original diagonal in zr
////	if (retval) return (-1.0); // do_error_nonsymmetric C matrix
//	if (!(z_tmp))ierr=write_matrix_to_SD(c,m,m,"z.dat");else copy_matrix(m,m,z_tmp,c);
//	retval=choltransform(b, c , m);
////  calculate eigenvalues and transformed eigenvectors
//	complexresult=eig(b, c, zr, zi , m, m, evlOnly); // save memory, return real eigenvectors in c
//	if (complexresult) return (-2.0); // do error  B matrix
//	copy_matrix(m,m,b,c); //copy to b
//// transform eigenvectors back  B <- U*B   or simply B/U
//	if (!(c_tmp)) ierr=read_matrix_from_SD(c  , &m, &m, "z.dat"); else copy_matrix(m,m,c,z_tmp);
//	cholbacksolve(m , c, b);  //  b is the eigenvector
//	if (!(doRms)) return (0.0);
//// store a copy of the eigenvector
//	if (!(b_tmp))ierr=write_matrix_to_SD(b,m,m,"z.dat");else copy_matrix(m,m,z_tmp,b);
//
//// calculate rms - error for each eigenvector
//	//  b,z
//	if (!(b_tmp)) ierr=read_matrix_from_SD(b, &m, &m, "b.dat"); else copy_matrix(m,m,b,b_tmp);
//	if (!(c_tmp)) ierr=read_matrix_from_SD(c, &m, &m, "z.dat"); else copy_matrix(m,m,c,z_tmp);
//	mult_matrix(m,m,m,m,b,c,c,FALSE); //  b*z -> b
//	if (!(b_tmp))ierr=write_matrix_to_SD(c,m,m,"b.dat");else copy_matrix(m,m,b_tmp,c);
////  c,z
//	if (!(c_tmp)) ierr=read_matrix_from_SD(c, &m, &m, "c.dat"); else copy_matrix(m,m,c,c_tmp);
//	if (!(b_tmp)) ierr=read_matrix_from_SD(b, &m, &m, "z.dat"); else copy_matrix(m,m,b,z_tmp);
//	mult_matrix(m,m,m,m,c,b,b,FALSE); //  c*z -> c
//// load b*z
//	if (!(c_tmp)) ierr=read_matrix_from_SD(c, &m, &m, "b.dat"); else copy_matrix(m,m,c,b_tmp);
//	mult_mat_diag(m,m,b,zr,b);
//	add_matrix(m,m,c,b,c,-1);
//	rms=sqrt(matnorm2(m,m,c))/m;
//	if (!(b_tmp)) ierr=read_matrix_from_SD(b, &m, &m, "z.dat"); else copy_matrix(m,m,b,z_tmp);
//	return (rms);
//}
//int do_choltransform(){
//	int m,n, retval;
//	double **B, **U;
//	U=sat_create_pop_double_matrix(&m, &n); // in: cholesky transformed in upper
//	B=sat_create_pop_double_matrix(&m, &n);
//	if (!(m==n)) { sat3_exiterror(Invalid_Dimensions); return (DO_ERROR_EXIT); }
//	retval=choltransform(B, U, m);
//if (retval==0)	sat_push_double_matrix(m, n, B);
//if (retval==0)	sat_push_double_matrix(m,n,U);
//	free_matrix2(m,n,B);
//	free_matrix2(m,n,U);
//	return (retval);
//}
//
//int choltransform(double **B, double **U, int m){
///*                      inout,      transform,
//*         or B <-- ((U**T)^-1)B (U^-1)
//*            only upper part of U is accessed
//*/
//	int i,k, step;
//	double sum=0.0, *tmp;
//	tmp=create_vector(m);
//// 1st step
//	for (step=1;step<=2;step++){
//		for (k=0;k<m;k++){
////			B[k][0]= B[k][0]/U[0][0];
//			for (i=0;i<m;i++){
//				B[k][i]=(B[k][i]-dotvector(sum,B[k],getcolvector(U, tmp, i,i),i))/U[i][i];
//				}
//			}
//		transp(m,B);
//	}  // repeat step 1 once more
//	free(tmp);
//	return (0);
//}
//
//int cholbacksolve(int n , double **U, double **E){
////              x <- ax=b        a:in    b;inout	 UW=E
//	int i,j,k,kb;
//	double t;
//        for (j=0;j<n;j++){
///* Now solve u * x = y. */
//			for (kb = 0; kb < n; kb++) {
//				k = n - kb-1;
//				E[k][j] /= U[k][k];
//				t = -E[k][j];
///*		saxpy(k-1,t,a(1,k),1,b(1),1); */
//				for (i = 0; i < k ; i++)
//					E[i][j] += (t * U[i][k]); // col Ej=Ej+t*Uk
//			}
//		}
//    return(0);
//}
/*
double calc_geneig_res(double **B, double **C,  double **Z, double *lam, int m){
// cost: require 3 full matrixes -> too expensive
	int i,j,k;
double t, t2, rms=0;
    t2=0.0;
    for (i=0;i<m;i++){for (j=0;j<m;j++){t=0; for (k=0;k<m;k++){
    	t+=(B[i][k] - lam[j]*C[i][k])*Z[k][j];}
    t2+=t*t;}}
    rms=sqrt(t2)/m;
return (rms);
}
*/
//#include <fsystem.h>
//int
//write_matrix_to_SD(double **a, int m, int n, char* name  )
//{
//	int i, flag;
////	void *pv;
//	FS_FILE *fileptr;
//	flag= FSOpen(name, FSMODE_WRITE, &fileptr);
//	if (!(flag==FS_OK)){printf("\n OPEN Error \n write mat from SD"); WAIT_CANCEL }
//
////	pv=&m;
//	flag=FSWrite((void*)&m,4,fileptr);
//	flag=FSWrite((void *)&n,4,fileptr);
//	for(i=0;i<m;i++){
//
//			flag=FSWrite( (void *)a[i],8*n,fileptr);
//
//	}
//	flag=FSClose(fileptr);
//	if (!(flag==FS_OK)){printf("\n Close Error \n Write mat from SD"); WAIT_CANCEL }
//	return (flag);
//}
//int
//read_matrix_from_SD(double **a, int *m, int *n, char* name  )
//{
//	int i,j,flag;
//	void *ptr;
//	FS_FILE *fileptr;
//	flag=FSOpen(name, FSMODE_READ, &fileptr);
//	if (!(flag==FS_OK)){printf("\n Error \n read mat from SD"); WAIT_CANCEL }
//	flag=FSRead((char *)m,4,fileptr);
//	flag=FSRead((char *)n,4,fileptr);
//	j=*n*8;
//	for(i=0;i< *m;i++){
//		ptr=a[i];
//		flag=FSRead(ptr, j,fileptr);
//
////		for(j=0;j< *n;j++){
////			flag=FSRead((void *)&a[i][j],8,fileptr);
////		}
//	}
//
//	flag=FSClose(fileptr);
//	if (!(flag==FS_OK)){printf("\n Closing Error \n read mat from SD"); WAIT_CANCEL }
//	return flag;
//}
//int
//read_matrix_dims_from_SD(int *m, int *n, char* name  )
//{
//	int flag;
//	FS_FILE *fileptr;
//	flag=FSOpen(name, FSMODE_READ, &fileptr);
//	if (!(flag==FS_OK)){printf("\n Error \n read mat dims"); WAIT_CANCEL }
//	flag=FSRead((char *)m,4,fileptr);
//	flag=FSRead((char *)n,4,fileptr);
//
//	flag=FSClose(fileptr);
//	return flag;
//}
//
