/*
 * misc.c
 *
 *  Created on: Jan 26, 2015
 *      Author: skai
 */
#include "main.h"

BOOL
sat_push_double_vector_0(int n,double *vector){
	int j;
	SAT_OBJECT sat_array;
	if (!(n))sat3_exiterror(SATERR_INVALIDDIMENSION);
    sat_array=sat3_createrarray(ALLOC_TEMPOB,n,0);
    if(sat_array==0){ sat3_exiterror( SATERR_INSUFFMEMORY ); return FALSE;}
    if (!(get_sysflag(HPSYSFLAG_TINY_ELEMENT))){
    	for (j=0;j<n;j++)if(fabs(vector[j])<1e-13)vector[j]= 0.0;}
    for (j=0;j<n;j++) sat3_rarrayput_dbl( sat_array,j,0,vector[j]);
    sat3_push(sat_array);
    return TRUE;
}

void							/* create constant vector of double */
const_vector(int n, double r, double *v)
{
	int i;
	for (i = 0; i < n; i++)
		v[i] = r;
}


double *
create_vector(int m)
{
     // Dynamically allocate an n vector
	double r=0.0;
	double *vec;
	if(!(vec = (double *) calloc(m,sizeof(double)))){sat3_exiterror(SATERR_INSUFFMEMORY); return (0);}
	const_vector(m,r,vec); //	for (i=0;i<m;i++) {vec[i]=r;}
	return (vec);
}

double *
sat_create_pop_double_vector(int *n)
{
// double sat3_pop_dbl(0.0)
	SAT_OBJECT	eaddr;
int flag=0, rows=0,cols=0,j;
double *vector=0;

	if(sat3_depth()==0) sat3_exiterror(Too_Few_Arguments); //error: too few arguments
    eaddr= sat3_pick(1) ;
	if (!(flag=sat3_rarraysize(eaddr,&rows, &cols)))sat3_exiterror( Bad_Argument_Type );   //error: not an arry
	if ((cols))  sat3_exiterror( SATERR_INVALIDDIMENSION);
	if (!( vector=create_vector(rows))) sat3_exiterror(SATERR_INSUFFMEMORY);
	for (j=0;j<rows;j++) vector[j]=sat3_rarrayget_dbl( eaddr,j,0);
    sat3_drop(); //pop the vector from the stack
    *n=rows;
	return (vector);
}

//int
//write_vector_to_SD(double *a, int n, char* name  )
//{
//	int flag;
////	void *pv;
//	FS_FILE *fileptr;
//	flag= FSOpen(name, FSMODE_WRITE, &fileptr);
//	if (!(flag==FS_OK)){printf("\n OPEN Error \n write mat from SD"); WAIT_CANCEL }
//	flag=FSWrite((void *)&n,4,fileptr);
//	flag=FSWrite( (void *)a,8*n,fileptr);
//	flag=FSClose(fileptr);
//	if (!(flag==FS_OK)){printf("\n Close Error \n Write mat from SD"); WAIT_CANCEL }
//	return (flag);
//}
//int
//read_vector_from_SD(double *a, int *n, char* name  )
//{
//	int j,flag;
//	void *ptr;
//	FS_FILE *fileptr;
//	flag=FSOpen(name, FSMODE_READ, &fileptr);
//	if (!(flag==FS_OK)){printf("\n Error \n read mat from SD"); WAIT_CANCEL }
//	flag=FSRead((char *)n,4,fileptr);
//	j=*n*8;
//
//		ptr=a;
//		flag=FSRead(ptr, j,fileptr);
//
////		for(j=0;j< *n;j++){
////			flag=FSRead((void *)&a[i][j],8,fileptr);
////		}
//
//
//	flag=FSClose(fileptr);
//	if (!(flag==FS_OK)){printf("\n Closing Error \n read mat from SD"); WAIT_CANCEL }
//	return flag;
//}
//int
//read_vector_dims_from_SD(int *n, char* name  )
//{
//	int flag;
//	FS_FILE *fileptr;
//	flag=FSOpen(name, FSMODE_READ, &fileptr);
//	if (!(flag==FS_OK)){printf("\n Error \n read mat dims"); WAIT_CANCEL }
//	flag=FSRead((char *)n,4,fileptr);
//
//	flag=FSClose(fileptr);
//	return flag;
//}

void scalevec(double *a, double f, int n0, int n1){
	int j;
    for (j = n0; j < n1; j++) a[j] *= f;
}


//void sat_get_hpdigits(){
//	int digits=0;
////	if (debug) return(10);
//	digits=get_sysflag(0+HPDIGITS_FLAG)
//	      | (get_sysflag(1+HPDIGITS_FLAG)<<1)
//		  | (get_sysflag(2+HPDIGITS_FLAG)<<2)
//		  | (get_sysflag(3+HPDIGITS_FLAG)<<3) ;
//		  if(!(digits)&&(get_sysflag(FIX_ENG_FLAG)||get_sysflag(SCI_ENG_FLAG))) digits=13;
//	hpdigits=digits;
//}
//
//
//void sat_get_mode(){
//	int m;
////	if (debug) return(1);
//					// mode =0  <-  DEG  <- -17 clear  -18 clear
//					// mode =1  <-  RAD  <- -17 set
//					// mode =2  <-  GRAD <- -17 clear  -18 set
//	if (get_sysflag(RAD_FLAG)) m=1; else m=(get_sysflag(1+RAD_FLAG)<<1);
//    &mode=m;
//}
//

//BOOL get_sysflag( int sysflag){
//	int nibble, bit,flag=0;
//	sysflag--;   									// sysflag start at 1 , change numbering to 0
//	nibble=sat3_peek(  SYSFLAG + sysflag/4, 1 );  	// read nibble  ( 4 flags)
//	bit=sysflag%4; 	// 								// calculate which bit our flag is
//	flag=(nibble>>bit)&1;							// pick out the flag we are looking for
///*
//	if (bit==0) flag=nibble& 1;
//	if (bit==1) flag=(nibble& 2)>>1;
//	if (bit==2) flag=(nibble& 4)>>2;
//	if (bit==3) flag=(nibble& 8)>>3;
//*/
//	return(flag);
//}
