/*
 * main.c
 *
 *  Created on: Feb 15, 2015
 *      Author: skai
 */


#include <hpgcc3.h>


// SUGGESTION: USE CUSTOM CONFIGURATION
// THIS STATEMENT WILL DISABLE KEYBOARDS AND TIMERS
// SO tmr_xxx FUNCTIONS WON'T WORK
//ARMCODE_CONFIG_STACK_STANDARD

// TO KEEP THE KEYBOARD AND TIMERS ENABLED, USE INSTEAD:
//ARMCODE_CONFIG(startup)=_NO_SCREEN | _NO_STDIO_INIT | _NO_WAITKEY | _NO_SPEEDCHANGE;
//ARMCODE_CONFIG(memory_req)=USE_MAINRAM|USE_ERAM|USE_KOSRAM|RESERVE_TEMPOB(16)|RESERVE_USEROB(16);

// AND SINCE YOUR PROGRAM USES THE SCREEN, THE BEST CHOICE IS:
ARMCODE_CONFIG(startup)= /*_NO_SCREEN | _NO_STDIO_INIT | */ _NO_WAITKEY | /*_NO_SPEEDCHANGE*/ _SPEED_120MHZ;
ARMCODE_CONFIG(memory_req)=USE_MAINRAM|USE_ERAM|USE_KOSRAM|RESERVE_TEMPOB(16)|RESERVE_USEROB(16);
ARMCODE_CONFIG(slack_space)=10;


void sort_vector(int, double *b, double *a, double *c);	// a(b), c is scratch (if c=b, b sort too)
BOOL sat_push_double_vector(int elements,double *vector);
//BOOL sat_push_double_cmatrix(int rows,int columns,double **rarray, double **iarray);
//BOOL sat_push_double_cvector(int n,double *rvector, double *ivector);
double * sat_create_pop_double_vector(int *elements);
//double ** sat_create_pop_double_matrix(int *m,int *n);
int *  create_int_vector(int n);
void	const_vector(int n, double r, double v[]);
// void	const_matrix(int m, int n, double r, double **mat);
double *  create_vector(int n);
#define SWAP(a,b) tempr=(a);(a)=(b);(b)=tempr

int forced_to_matrix=0;
int push_as_vector=0;


void							/* create constant vector of double */
const_vector(int n, double r, double *v)
{
	int i;
	for (i = 0; i < n; i++)
		v[i] = r;
}




void							/* create constant matrix of double */

const_matrix(int m, int n, double r, double **mat)
{
	int i,j;
	for (i = 0; i < m; i++){for (j=0;j<n;j++){ mat[i][j]=r;}}
}

BOOL
sat_push_double_vector(int n,double *vector){
	int j;
	SAT_OBJECT sat_array;
    sat_array=sat3_createrarray(ALLOC_TEMPOB,n,0);
    if(sat_array==0){ sat3_exiterror(SATERR_INSUFFMEMORY); return FALSE;}
    for (j=0;j<n;j++) sat3_rarrayput_dbl( sat_array,j,0,vector[j]);
    sat3_push(sat_array);
    return TRUE;
}

//BOOL
//sat_push_double_cvector(int n,double *rvector, double *ivector){
//	int j;
//	SAT_OBJECT sat_array;
//    sat_array=sat3_createcarray(ALLOC_TEMPOB,n,0);
//    if(sat_array==0){ sat3_exiterror(Insufficient_Memory); return FALSE;}
//    for (j=0;j<n;j++) sat3_carrayput_dbl( sat_array,j,0,rvector[j], ivector[j]);
//    sat3_push(sat_array);
//    return TRUE;
//}
//


double *
sat_create_pop_double_vector(int *n)
{
// double sat3_pop_dbl(0.0)
	SAT_OBJECT	eaddr;
int flag=0, rows=0,cols=0,j;
double *vector=0;

	if(sat3_depth()==0) sat3_exiterror(SATERR_TOOFEWARGS); //error: too few arguments
    eaddr= sat3_pick(1) ;
	if (!(flag=sat3_rarraysize(eaddr,&rows, &cols)))sat3_exiterror( SATERR_BADARGTYPE);   //error: not an arry
	if ((cols))  sat3_exiterror(SATERR_INVALIDDIMENSION);
	if (!( vector=create_vector(rows))) sat3_exiterror(SATERR_INSUFFMEMORY);
	for (j=0;j<rows;j++) vector[j]=sat3_rarrayget_dbl( eaddr,j,0);
    sat3_drop(); //pop the vector from the stack
    *n=rows;
	return (vector);
}


int *
create_int_vector(int m)
{
     // Dynamically allocate an n integer array
	int *list,i;
	if(!(list = (int *) calloc(m,sizeof(int)))){sat3_exiterror(SATERR_INSUFFMEMORY); return (0);}
	for (i=0;i<m;i++) {list[i]=0;}
	return (list);
}


void							/* copy vector vector of double */
copy_vector(int n, double *v0, double *v1)
{
	int i;
	for (i = 0; i < n; i++)
		v1[i] = v0[i];
}


double *
create_vector(int m)
{
     // Dynamically allocate an n vector
	double r=0.0;
	double *vec;
	if(!(vec = (double *) calloc(m,sizeof(double)))){sat3_exiterror(SATERR_INSUFFMEMORY); return (0);}
	const_vector(m,r,vec); //	for (i=0;i<m;i++) {vec[i]=r;}
	return (vec);
}

 void							/* sort a based on b , vector of double */
 sort_vector(int n, double *b, double *a, double *t)
 {
 	int i, j, p;
 	double r0, r1;
 	copy_vector(n, b, t);		//copy b to t, if t=b , b will be sorted too

 	for (i = 0; i < n - 1; i++)
 	{							//loop over vector
 		p = i;
 		r0 = 1e100;
 		for (j = i; j < n; j++)
 		{
 			if (r0 > t[j])
 			{
 				p = j;
 				r0 = t[j];
 			}
 		}						// find smallest
 		r1 = t[i];t[i] = r0;   t[p] = r1;
 		r1 = a[i];a[i] = a[p]; a[p] = r1;				// swap
 	}
 }


int main()
{

	int task_to_do = 0;
	int n1,n2,n;
    double *v1=0, *v2=0;
    if(sat3_checkargs(1,SAT_DOREAL))task_to_do=sat3_convertreal_int(sat3_pick(1));
	if( task_to_do==1){
		sat3_checkargserror(2, SAT_DOREAL,SAT_DOARRY);
		sat3_drop();
		v1= sat_create_pop_double_vector(&n1);
		v2=create_vector(n2=n1);
		n=n1;
		sort_vector(n,v1,v2,v1);
		sat_push_double_vector(n, v1);
	}
else if (task_to_do==2){
	sat3_checkargserror(3, SAT_DOREAL,SAT_DOARRY,SAT_DOARRY);
	sat3_drop();
	v2= sat_create_pop_double_vector(&n2);
	v1= sat_create_pop_double_vector(&n1);
	if (!(n1==n2)) sat3_exiterror(SATERR_INVALIDDIMENSION);
	n=n1;
	sort_vector(n,v2,v1,v2); // simple way to ensure that complex pairs are sorted consistently
	sort_vector(n,v1,v2,v1);
	sat_push_double_vector(n, v1);
	sat_push_double_vector(n, v2);

}

    free(v1);
    free(v2);

return (0);
}
